<!doctype html>
<html lang="en">
  <head>
    <!-- Required meta tags -->
    <title>Create Product</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="//stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css">
    <link rel="stylesheet" href="//stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css">
    <link rel="stylesheet" type="text/css" href="/dap/admin/css/dapCreatePaymentButtonsDoc.css">
    <link href="https://fonts.googleapis.com/css?family=Open+Sans:300,400,600,700,800i&display=swap" rel="stylesheet">

    
  </head>
  <body>
    <div id="create_payment_button_wrapper" style="box-shadow: 0px 0px 8px 0px #ddd;">
      <div class="row">
      	<div class="col-md-12">
      		<h1 class="main_heading">How to Create Payment Buttons to Sell your Products</h1>
      	</div>
      	<div class="col-md-6">
      		<div class="left_text active">
	      		<label class="custom_checkbox">
			    	<span class="checkmark_circle"></span>
			  	</label>
			  	<div class="checkbox_text">
			  		<h4>Generate Payment Buttons</h4>
			  		<p>You can create payment buttons to sell your products in your shopping cart platform or in the payment processor such as Paypal and publish on your sales page. As long as you integrate your payment buttons with DAP, upon successful purchase, buyers will automatically get access to the right product in DAP, and DAP will send out the welcome email with login/download credentials that you configure in DAP products page.</p>
			  		<p>For e.g., If you have three products (or "levels") called "Platinum Members", "Gold Members" and "Silver Members" in DAP, then you can generate 3 different buy buttons, one for each product, and publish it on your sales page. When users complete purchase, they'll get access to the right level/product in DAP and can instantly access content.</p>
			  	</div>
			</div>
			<div class="left_text">
	      		<label class="custom_checkbox">
			    	<span class="checkmark_circle"></span>
			  	</label>
			  	<div class="checkbox_text">
			  		<h4>SmartPayCart.com (SPC)</h4>
			  		<p>You can use a shopping cart plugin like SmartPayCart.com (SPC) to create your buy buttons and integrate SPC with Stripe/Authnet (for credit card payment) and/or Paypal. SPC is a cart platform that we built specifically for DAP. It integrates really well with DigitalAccessPass.com.</p>
			  		<p>Watch the video to your right to see how you can quickly and easily create buy buttons and checkout pages using SmartPayCart (SPC).</p>
			  	</div>
			</div>
			<div class="left_text">
	      		<label class="custom_checkbox">
			    	<span class="checkmark_circle"></span>
			  	</label>
			  	<div class="checkbox_text">
			  		<h4>External Shopping Cart Platform</h4>
			  		<p>If you want to use an external shopping cart platform, that's fine too. DAP integrates with several shopping cart platforms. You'll find detailed integration information in our documentation.</p>
			  		<p>Click on the button below to access DAP documentation.</p>
			  		<a href="//digialaccesspass.com/documentation" class="dap_documentation_btn">Dap Documentation</a>
			  	</div>
			</div> 
      	</div>
      	<div class="col-md-6">
      		<div class="right_video">  
				<h4>Start Selling in Less Than 5 Minutes Using SPC</h4>
      			<iframe width="100%" height="380" src="https://www.youtube.com/embed/YZIFiHRxfDM" frameborder="0" allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>
      		</div>
      		<div class="right_video">
				<h4>SmartPayCart vs Other Cart Platforms</h4>
      			<iframe width="100%" height="380" src="https://www.youtube.com/embed/h6Ro82mQ2bo" frameborder="0" allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>
      		</div>
      	</div>
      </div>
    </div>

    <!-- Optional JavaScript -->
    <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js"></script>
  </body>
</html>
