<?php

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_course_module` (
`id` int(11) NOT NULL AUTO_INCREMENT,
`module_name` varchar(255) NOT NULL,
`module_desc` longtext NULL,
`course_id` int(11) NOT NULL,
`module_display_order` int(11) NULL,
`date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_user_course_progress` (
`id` int(11) NOT NULL AUTO_INCREMENT,
`user_id` int(11) NOT NULL,
`product_id` int(11) NOT NULL,
`module_id` int(11) NOT NULL,
`unit_id` int(11) NOT NULL,
`completed` varchar(255) NULL,
`date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_products_tabs` (
`id` int(11) NOT NULL AUTO_INCREMENT, 
`product_id` int(11) NOT NULL,
`tab_list` text NULL,
`maintain` varchar(255) NULL,
PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_onlinecourse` (
`id` int(11) NOT NULL AUTO_INCREMENT, 
`name` varchar(255) NULL,
`course_id` varchar(255) NULL,
`html` longtext NULL,
`customize_data` text NULL,
`date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8"; 


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_failed_payment_settings` (
`id` int(11) NOT NULL AUTO_INCREMENT,
`payment_processor` varchar(50) NOT NULL,
`transaction_type` varchar(100) NOT NULL,
`subject` varchar(255) NOT NULL,
`body` mediumtext NOT NULL,
`send_email` varchar(10) NOT NULL,
PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8"; 


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_users_products_failed_payments` (
`id` int(11) NOT NULL AUTO_INCREMENT,
`user_id` int(11) NOT NULL,
`product_id` int(11) NOT NULL,
`payment_processor` varchar(20) NOT NULL,
`transaction_type` varchar(100) NOT NULL,
`reason` varchar(255) NOT NULL,
`action` varchar(255) NOT NULL,
`transaction_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8"; 


$sql_ddl[] = "ALTER TABLE `dap_products_resources_jn` ADD `module_id` INT(11) NULL AFTER `cond_drip_order`";

$sql_ddl[] = "ALTER TABLE `dap_products` ADD `product_type` VARCHAR(255) NULL DEFAULT NULL AFTER `stripe_failed_payment_cancellation_body`, ADD `product_structure` VARCHAR(255) NULL DEFAULT NULL AFTER `product_type`";

$sql_ddl[] = "ALTER TABLE `dap_products` ADD `course_email_subject` TEXT NULL DEFAULT NULL AFTER `product_structure`, ADD `course_email_body` TEXT NULL DEFAULT NULL AFTER `course_email_subject`, ADD `module_email_subject` TEXT NULL DEFAULT NULL AFTER `course_email_body`, ADD `module_email_body` TEXT NULL DEFAULT NULL AFTER `module_email_subject`, ADD `lesson_email_subject` TEXT NULL DEFAULT NULL AFTER `module_email_body`, ADD `lesson_email_body` TEXT NULL DEFAULT NULL AFTER `lesson_email_subject`";

$sql_ddl[] = "ALTER TABLE `dap_products` ADD `offer_trial` VARCHAR(255) NULL DEFAULT NULL AFTER `lesson_email_body` , ADD `course_progress` VARCHAR(255) NULL DEFAULT NULL AFTER `offer_trial`";

$sql_ddl[] = "ALTER TABLE `dap_products` ADD `course_complete_message` TEXT NULL AFTER `course_progress`, ADD `module_complete_message` TEXT NULL AFTER `course_complete_message`, ADD `lesson_complete_message` TEXT NULL AFTER `module_complete_message`";

$sql_ddl[] = "ALTER TABLE `dap_products`  ADD `free_trial` VARCHAR(255) NULL DEFAULT NULL  AFTER `lesson_complete_message`";

$sql_ddl[] = "ALTER TABLE `dap_products` ADD `last_payment_access` VARCHAR(10) NULL AFTER `free_trial`, ADD `last_payment_days` VARCHAR(10) NULL AFTER `last_payment_access`, ADD `access_after_final_payment` VARCHAR(10) NULL AFTER `last_payment_days`, ADD `access_limit` VARCHAR(10) NULL AFTER `access_after_final_payment`";

$sql_ddl[] = "ALTER TABLE `dap_products` ADD `send_course_complete` VARCHAR(255) NULL AFTER `access_limit`, ADD `send_module_complete` VARCHAR(255) NULL AFTER `send_course_complete`, ADD `send_lesson_complete` VARCHAR(255) NULL AFTER `send_module_complete`";

$sql_ddl[] = "ALTER TABLE `dap_transactions`  ADD `spc_payment_num` VARCHAR(255) NULL DEFAULT NULL  AFTER `credits_used`";

$sql_ddl[] = "ALTER TABLE `dap_transactions` CHANGE `trans_type` `trans_type` VARCHAR(50) NOT NULL DEFAULT ''";

$sql_ddl[] = "INSERT INTO `dap_failed_payment_settings` (`payment_processor`, `transaction_type`, `subject`, `body`, `send_email`) VALUES ( 'PAYPAL', 'recurring_payment_skipped', 'Paypal Payment Skipped', 'Looks like your Paypal couldn\'t process your payment for %%PRODUCT_NAME%%. Paypal will retry again but we just wanted you to be aware.\r\n\r\nPlease log in to your Paypal account and update it so that there are sufficient funds in there when Paypal tries to charge your account again next time.\r\n\r\nKindly do this at the earliest to prevent any disruption in your service.', 'yes'), ( 'PAYPAL', 'recurring_payment_profile_cancel', 'Paypal Subscription Cancelled', '<p>Hi %%FIRST_NAME%%, </p><p>We just got a notification from Paypal that your subscription has been canceled for %%PRODUCT_NAME%%. Not sure if you canceled it from within Paypal, or maybe you changed your credit card or bank information within Paypal and that triggered this cancellation in error. If it was mistakenly cancelled, then please sign up for a new subscription here: ENTER URL HERE Please do this asap to avoid any disruption in your service.</p>', 'yes'), ( 'PAYPAL', 'recurring_payment_expired', 'Paypal Subscription Expired', '<p>Hi %%FIRST_NAME%%,</p><p> We just got a notification from Paypal that your subscription has expired for %%PRODUCT_NAME%%. Not sure if are you are aware of this. If it was mistakenly cancelled, then please sign up for a new subscription at: ENTER URL HERE Please do this asap to avoid any disruption in your service.</p>', 'yes'), ( 'PAYPAL', 'recurring_payment_suspended', 'Paypal Subscription Suspended', '<p>Hi %%FIRST_NAME%%, </p><p>We just got a notification from Paypal that your subscription was suspended for %%PRODUCT_NAME%%. Not sure if are you are aware of this. Please log in to your Paypal account and update it so that there are sufficient funds in there when Paypal tries to charge your account again next time. Please do this asap to avoid any disruption in your service.</p>', 'yes');";

$sql_ddl[] = "INSERT INTO `dap_failed_payment_settings` ( `payment_processor`, `transaction_type`, `subject`, `body`, `send_email`) VALUES ( 'AUTHNET', 'authnet_cancellation', 'Subscription Cancelled', '<p>Hi %%FIRST_NAME%%,</p><p>We just got a notification from payment processor that your subscription has been cancelled for %%PRODUCT_NAME%%.</p><p>If it was mistakenly cancelled, then please sign up for a new subscription here (or contact us for more details):</p><p>ENTER URL HERE</p><p>Please do this asap to avoid any disruption in your service.</p>', 'yes'), ( 'AUTHNET', 'authnet_expired', 'Your Credit Card has Expired', '<p>Looks like your credit card failed when trying to process your annual subscription.</p><p>Please do this asap to avoid any disruption in your service.</p><p>Once you have updated the billing info, payments should resume from the next month onwards.</p>', 'yes'), ( 'AUTHNET', 'subscription_terminated', 'Your Automated Recurring Billing (ARB) subscription has been terminated.', '<p>Looks like your credit card failed when trying to process your subscription.</p><p>And our payment processor terminated your credit card subscription.</p><p>If you wish to continue using them, please sign up again at the earliest.</p><p>Let us know if you have any further questions.</p>', 'yes'), ( 'AUTHNET', 'subscription_suspended', 'Your Automated Recurring Billing (ARB) subscription has been suspended.', 'If this subscription is not reactivated before the next scheduled payment date, the subscription will be terminated.', 'yes');";

//this should always be the last update
$sql_ddl[] = "UPDATE `dap_config` SET `value` = '7.9' WHERE  `name` = 'DAP_VERSION_CLIENT'  LIMIT 1";

?>