<?php

// Database for DAP

// Table structure for table `dap_aff_comm`
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_aff_comm` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `product_id` int(11) NOT NULL DEFAULT '0',
  `per_lead_fixed` decimal(7,2) NOT NULL DEFAULT '0.00',
  `per_sale_fixed` decimal(7,2) NOT NULL DEFAULT '0.00',
  `per_sale_percentage` int(3) NOT NULL DEFAULT '0',
  `per_lead_fixed_credits` int(11) DEFAULT NULL,
  `per_sale_fixed_credits` int(11) DEFAULT NULL,
  `per_sale_percentage_credits` int(11) DEFAULT NULL,
  `aff_owns_product` VARCHAR(10) NOT NULL DEFAULT 'N',
  `is_comm_recurring` char(1) NOT NULL DEFAULT '' COMMENT 'Y/N',
  `tier` int(3) NOT NULL DEFAULT '1',
  PRIMARY KEY (`user_id`,`product_id`,`tier`),
  UNIQUE KEY `id` (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8";


// Table structure for table `dap_aff_earnings`
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_aff_earnings` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `aff_referrals_id` int(11) NOT NULL DEFAULT '0',
  `amount_earned` decimal(7,2) NOT NULL DEFAULT '0.00',
  `datetime` TIMESTAMP NULL DEFAULT CURRENT_TIMESTAMP,
  `transaction_id` int(11) NOT NULL DEFAULT '0',
  `earning_type` char(2) NOT NULL COMMENT 'L-Lead, S-Sale, P-Payment, T-Tier',
  `aff_exports_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8";


// Table structure for table `dap_aff_exports`
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_aff_exports` (
  `id` int(11) NOT NULL auto_increment,
  `payment_status` varchar(20) NOT NULL,
 `datetime` TIMESTAMP NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 DEFAULT CHARSET=utf8";


// Table structure for table `dap_aff_payments`
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_aff_payments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `affiliate_id` int(11) NOT NULL DEFAULT '0',
  `amount_paid` decimal(7,2) NOT NULL DEFAULT '0.00',
  `datetime` TIMESTAMP NULL DEFAULT CURRENT_TIMESTAMP,
  `comments` text,
  `aff_exports_id` int(11) DEFAULT NULL,
  `earning_type` varchar(7) NOT NULL DEFAULT 'CASH',
  PRIMARY KEY (`id`),
  UNIQUE KEY `affiliate_id` (`affiliate_id`,`aff_exports_id`,`earning_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";


// Table structure for table `dap_aff_referrals`
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_aff_referrals` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `affiliate_id` int(11) NOT NULL DEFAULT '0',
  `product_id` int(11) NOT NULL DEFAULT '0',
  `tier` int(3) NOT NULL DEFAULT '1',
  `referral_date` TIMESTAMP NULL DEFAULT CURRENT_TIMESTAMP,
  UNIQUE KEY `userproductkey` (`user_id`,`product_id`,`affiliate_id`),
  KEY `id` (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8";


// Table structure for table `dap_aff_stats`
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_aff_stats` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `http_referer` varchar(200) NOT NULL DEFAULT '',
  `datetime` TIMESTAMP NULL DEFAULT CURRENT_TIMESTAMP,
  `useragent` varchar(50) NOT NULL DEFAULT '',
  `ip` varchar(20) NOT NULL DEFAULT '',
  `dest_url` varchar(100) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_blob` (
  `resource_id` int(11) NOT NULL,
  `content` longblob,
  `content_type` varchar(20) default NULL,
  `title` varchar(20) default NULL,
  `description` varchar(100) default NULL,
  KEY `resource_id` (`resource_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_cart` (
  `product_id` varchar(20) NOT NULL,
  `show_coupon` char(1) DEFAULT 'N',
  `show_howdidyouhearboutus` char(1) DEFAULT 'N',
  `show_shiptoaddress` char(1) DEFAULT 'N',
  `show_tandc` char(1) DEFAULT NULL,
  `tandc` text,
  `require_tandc_acceptance` char(1) DEFAULT 'N',
  `request_phone` char(1) DEFAULT 'N',
  `request_fax` char(1) DEFAULT 'N',
  `request_address2` char(1) DEFAULT 'N',
  `require_billing_for_paypal` char(1) DEFAULT 'Y',
  `choose_password` char(1) DEFAULT 'N',
  `request_company` char(1) DEFAULT 'N',
  `show_comments` text,
  `cart_header` text,
  `cart_footer` text,
  `checkout_submit_image_url` varchar(100) DEFAULT NULL,
  `custom_fields` text,
  PRIMARY KEY (`product_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_category` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `code` varchar(30) NOT NULL,
  `description` text,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8
";


// Table structure for table `dap_config`
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_config` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(20) NOT NULL default '',
  `value` varchar(255) NOT NULL default '',
  `description` varchar(100) default NULL,
  `editable` char(1) NOT NULL default 'Y',
  `type` varchar(15) NOT NULL default 'textbox',
  `values` text NOT NULL,
  `display_order` tinyint(4) default NULL,
  `category` varchar(10) default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8
";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_coupons` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `code` varchar(30) NOT NULL,
  `description` text,
  `start_date` date NULL,
  `end_date` date NULL,
  `discount_amt` decimal(7,2) NOT NULL DEFAULT '0.00',
  `recurring_discount_amt` decimal(7,2) NOT NULL DEFAULT '0.00',
  `discount_amt_percent` decimal(7,2) NOT NULL DEFAULT '0.00',
  `recurring_discount_amt_percent` decimal(7,2) NOT NULL DEFAULT '0.00',
  `discount_rate` int(3) DEFAULT '0',
  `max_usage` int(11) DEFAULT '0',
  `actual_usage` int(11) DEFAULT '0',
  `user_id` INT(11) NULL,
  `notify_affiliate` VARCHAR(10) NULL,
  `email_subject` TEXT NULL,
  `email_body` LONGTEXT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_credits` (
  `userid` int(11) NOT NULL,
  `type` varchar(100) NOT NULL,
  `used` int(11) NOT NULL,
  `postid` bigint(20) NOT NULL,
  `title` varchar(300) DEFAULT NULL,
  `credits` int(11) NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_custom_fields` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(20) NOT NULL,
  `label` varchar(200) NOT NULL,
  `description` text,
  `field_type` varchar(255) NOT NULL DEFAULT '',
  `field_value` varchar(255) NOT NULL DEFAULT 'N',
  `showonlytoadmin` char(1) NOT NULL DEFAULT 'N',
  `allow_delete` char(1) NOT NULL DEFAULT 'Y',
  `required` char(1) NOT NULL DEFAULT 'N',
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8";

 
// Table structure for table `dap_email_resources`
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_email_resources` (
  `id` int(11) NOT NULL auto_increment,
  `subject` varchar(100) NOT NULL default '',
  `message` text NOT NULL,
  `attachment` text,
  `sendTo3rdParty` char(1) default 'N' COMMENT 'Y or N',
  `thirdPartyEmailId` varchar(60) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
";


// Table structure for table `dap_emailorder_templates`
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_emailorder_templates` (
`id` INT NOT NULL AUTO_INCREMENT ,
`processor` VARCHAR( 40 ) NOT NULL ,
`blocks` VARCHAR( 50 ) NOT NULL ,
`template` TEXT NOT NULL ,
`last_update_ts` timestamp NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
PRIMARY KEY ( `id` )
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1";


// Table structure for table `dap_file_resources`
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_file_resources` (
  `id` int(11) NOT NULL auto_increment,
  `url` varchar(200) NOT NULL default '',
  `name` varchar(100) default NULL,
  `display_in_list` char(1) NOT NULL default 'Y',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `url` (`url`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1";


// Table structure for table `dap_log`
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_log` (
  `id` int(11) NOT NULL auto_increment,
  `logtime` datetime NOT NULL,
  `level` tinyint(4) NOT NULL,
  `msg` varchar(200) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";


// Table structure for table `dap_mass_actions`
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_mass_actions` (
  `id` int(11) NOT NULL auto_increment,
  `actionType` varchar(20) NOT NULL default '',
  `actionKey` varchar(200) NOT NULL default '000',
  `payload` text NOT NULL,
  `status` varchar(10) NOT NULL default 'NEW' COMMENT 'NEW',
  `comments` varchar(100) NOT NULL default '',
  `priority` tinyint(4) NOT NULL default '3',
  `last_update_ts` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `schedule_type` INT(11) NULL DEFAULT '1',
  `schedule_date` DATETIME NULL,
  `schedule_timezone` VARCHAR(255) NULL DEFAULT NULL,
  PRIMARY KEY  (`actionType`,`actionKey`),
  KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";


// Table structure for table `dap_notifications`
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_notifications` (
  `id` int(11) NOT NULL auto_increment,
  `notification_type` char(1) NOT NULL default '',
  `notification_email` varchar(60) NOT NULL default '',
  `notification_url` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";


// Table structure for table `dap_products`
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_products` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL DEFAULT '',
  `description` text,
  `error_page_url` varchar(100) DEFAULT NULL,
  `is_recurring` char(1) NOT NULL DEFAULT 'N',
  `price` decimal(10,2) NOT NULL DEFAULT '0.00',
  `trial_price` decimal(10,2) DEFAULT NULL,
  `total_occur` int(5) DEFAULT NULL,
  `recurring_cycle_1` smallint(6) DEFAULT NULL,
  `recurring_cycle_2` smallint(6) DEFAULT NULL,
  `recurring_cycle_3` smallint(6) DEFAULT NULL,
  `status` char(1) NOT NULL DEFAULT 'I',
  `notification_id` int(11) NOT NULL DEFAULT '0',
  `thankyou_page_url` varchar(100) DEFAULT NULL,
  `thirdPartyEmailIds` varchar(200) DEFAULT NULL,
  `sales_page_url` varchar(100) DEFAULT NULL,
  `self_service_allowed` char(1) NOT NULL DEFAULT 'N',
  `resell_product` char(1) NOT NULL DEFAULT 'N',
  `is_master` char(1) NOT NULL DEFAULT 'N',
  `allowContentLevelCredits` char(1) DEFAULT 'N',
  `product_image_url` varchar(200) DEFAULT NULL,
  `credits` int(11) DEFAULT '0',
  `double_optin_subject` varchar(100) DEFAULT NULL,
  `double_optin_body` text,
  `thankyou_email_subject` varchar(100) DEFAULT NULL,
  `thankyou_email_body` text,
  `logged_in_url` varchar(300) DEFAULT NULL,
  `selfservice_start_date` date DEFAULT NULL,
  `selfservice_end_date` date DEFAULT NULL,
  `subscribe_to` text DEFAULT NULL,
  `unsubscribe_from` text DEFAULT NULL,
  `price_increment` decimal(7,2) DEFAULT NULL,
  `price_increment_ceil` decimal(7,2) DEFAULT NULL,
  `num_sales` int(5) DEFAULT '0',
  `num_days` smallint(6) DEFAULT '0',
  `timed_pricing_start_date` date NULL,
  `is_free_product` char(1) NOT NULL DEFAULT 'N',
  `allow_free_signup` char(1) NOT NULL DEFAULT 'N',
  `recurring_credits` int(10) DEFAULT '0',
  `product_image_url_linkedto` varchar(100) DEFAULT NULL,
  `short_description` varchar(127) DEFAULT NULL,
  `long_description` text,
  `access_expiration_action` varchar(100) DEFAULT 'NOACTION',
  `renewal_redirect_url` varchar(100) DEFAULT NULL,
  `renewal_html` text,
  `access_upon_final_payment` smallint(6) DEFAULT NULL,
  `buy_link` text,
  `show_buy_link` char(1) NOT NULL DEFAULT 'N',
  `future_content_access` char(1) NOT NULL DEFAULT 'N',
  `drip_type` int(4) NOT NULL DEFAULT '1',
  `member_product_links_url` VARCHAR( 100 ) DEFAULT NULL,
  `stripe_payment_retry_subject` varchar(100) DEFAULT NULL,
  `stripe_payment_retry_body` text,
  `stripe_final_retry_subject` varchar(100) DEFAULT NULL,
  `stripe_final_retry_body` text,
  `stripe_failed_payment_cancellation_subject` varchar(100) DEFAULT NULL,
  `stripe_failed_payment_cancellation_body` text,
  `product_type` VARCHAR(255) DEFAULT NULL,
  `product_structure` VARCHAR(255) DEFAULT NULL,
  `course_email_subject` TEXT DEFAULT NULL,
  `course_email_body` TEXT DEFAULT NULL,
  `module_email_subject` TEXT DEFAULT NULL,
  `module_email_body` TEXT DEFAULT NULL,
  `lesson_email_subject` TEXT DEFAULT NULL,
  `lesson_email_body` TEXT DEFAULT NULL,
  `offer_trial` VARCHAR(255) DEFAULT NULL,
  `course_progress` VARCHAR(255) DEFAULT NULL,
  `course_complete_message` TEXT DEFAULT NULL,
  `module_complete_message` TEXT DEFAULT NULL,
  `lesson_complete_message` TEXT DEFAULT NULL,
  `last_payment_access` VARCHAR(10) DEFAULT NULL,
  `last_payment_days` VARCHAR(10) DEFAULT NULL,
  `access_after_final_payment` VARCHAR(10) DEFAULT NULL,
  `access_limit` VARCHAR(10) DEFAULT NULL,
  `send_course_complete` VARCHAR(255) DEFAULT NULL,
  `send_module_complete` VARCHAR(255) DEFAULT NULL, 
  `send_lesson_complete` VARCHAR(255) DEFAULT NULL,
  `free_trial` VARCHAR(10) DEFAULT NULL, 
  `account_type` VARCHAR(50) DEFAULT NULL, 
  `max_count` int(11) DEFAULT NULL,
  `double_optin` VARCHAR(50) DEFAULT NULL,
  `expiration_remove_rule` VARCHAR(255) DEFAULT NULL,
  `skip_module` VARCHAR(255) DEFAULT NULL,
  `magazine_model` VARCHAR(1) DEFAULT NULL,
  `related_courses` VARCHAR(100) DEFAULT NULL,
  `course_type` varchar(10) DEFAULT NULL,
  `course_status` varchar(10) DEFAULT NULL,
   PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_productchaining` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `source_operation` varchar(50) NOT NULL,
  `source_product_id` int(11) NOT NULL,
  `target_operation` varchar(50) NOT NULL,
  `target_product_id` int(11) NOT NULL,
  `payment_processor_action` VARCHAR(10) NOT NULL DEFAULT 'D',
  `transaction_id` int(11) NOT NULL,
  `add_days` int(11) NOT NULL DEFAULT '0',
  `send_welcome_email` char(1) NOT NULL DEFAULT 'Y',
  `future_access_date` TIMESTAMP NULL on update CURRENT_TIMESTAMP,
  `comment` text,
  PRIMARY KEY (`id`),
  UNIQUE KEY `uniqueindex` (`source_operation`,`source_product_id`,`target_operation`,`target_product_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_products_category_jn` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `product_id` int(11) NOT NULL,
  `category_id` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `productcategorykey` (`product_id`,`category_id`),
  KEY `product_id` (`product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_products_coupons_jn` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `product_id` int(11) NOT NULL,
  `coupon_id` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `productcouponkey` (`product_id`,`coupon_id`),
  KEY `product_id` (`product_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8";


// Table structure for table `dap_products_resources_jn`
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_products_resources_jn` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `product_id` int(11) NOT NULL DEFAULT '0',
  `module_id` INT(11) DEFAULT NULL,
  `resource_id` int(11) NOT NULL DEFAULT '0',
  `sss_enabled` char(1) DEFAULT 'N',
  `credits_assigned` int(4) DEFAULT NULL,
  `excerpt` text,
  `is_free` char(1) NOT NULL DEFAULT 'N',
  `start_day` int(4) DEFAULT '1',
  `end_day` int(4) DEFAULT '9999',
  `start_date` date DEFAULT NULL,
  `end_date` date DEFAULT NULL,
  `num_clicks` int(4) DEFAULT NULL,
  `resource_type` char(1) NOT NULL DEFAULT '',
  `status` char(1) NOT NULL DEFAULT 'A',
  `display_order` int(4) DEFAULT '1',
  `file_resource_id` int(11) DEFAULT '0',
  `pay_per_post` decimal(7,2) DEFAULT '0.00',
  `cond_drip_order` decimal(5,3) DEFAULT '0.000',
  `course_calculation` CHAR(1) DEFAULT NULL,
  `deleted` CHAR(1) DEFAULT NULL,
  `deleted_date` TIMESTAMP NULL DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `product_id_2` (`product_id`,`resource_id`,`resource_type`,`start_day`),
  KEY `product_id` (`product_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;
";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_products_mc_sss_jn` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `master_product_id` int(11) NOT NULL,
  `child_product_id` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `masterchildkey` (`master_product_id`,`child_product_id`),
  KEY `master_product_id` (`master_product_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1";


// Table structure for table `dap_smtp_servers`
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_smtp_servers` (
`id` int(11) NOT NULL auto_increment,
`description` varchar(30) NOT NULL,
`server` varchar(50) NOT NULL,
`port` int(11) NOT NULL default '25',
`ssl` varchar(1) NOT NULL default 'N',
`userid` varchar(50) NOT NULL,
`password` varchar(350) NOT NULL,
`limit_per_hour` int(11) NOT NULL default '100',
`running_total` int(11) NOT NULL default '0',
`active` varchar(1) NOT NULL default 'Y',
`last_updated_ts` timestamp NOT NULL default CURRENT_TIMESTAMP,
PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";


$sql_ddl[] = "
	CREATE TABLE IF NOT EXISTS `dap_supportticket` (
		`id` int(11) NOT NULL AUTO_INCREMENT,
		`source_product_id` int(11) NOT NULL,
		`support_access_url` varchar(200) NOT NULL,
		`comment` text,
		`support_product_id` varchar(255) NULL DEFAULT NULL,
		`support_rule` varchar(255) DEFAULT NULL,
		PRIMARY KEY (`id`)
	) ENGINE=InnoDB  DEFAULT CHARSET=utf8
	";


// Table structure for table `dap_templates`
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_templates` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL,
  `description` varchar(50) NOT NULL,
  `category` varchar(10) NOT NULL,
  `content` text NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1";


// Table structure for table `dap_transactions`
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_transactions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `trans_num` varchar(50) NOT NULL DEFAULT '0',
  `trans_type` varchar(50) NOT NULL DEFAULT '',
  `payment_status` varchar(20) NOT NULL DEFAULT '',
  `payment_currency` varchar(20) NOT NULL DEFAULT '',
  `payment_value` decimal(7,2) DEFAULT '0.00',
  `payer_email` varchar(60) NOT NULL DEFAULT '',
  `sub_trans_num` varchar(30) NOT NULL DEFAULT '',
  `payment_processor` varchar(20) NOT NULL DEFAULT '',
  `time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `date` date null,
  `trans_blob` text NOT NULL,
  `product_id` int(11) NOT NULL DEFAULT '0',
  `user_id` int(11) DEFAULT NULL,
  `coupon_id` int(11) DEFAULT NULL,
  `credits_used` VARCHAR(255) DEFAULT NULL,
  `status` tinyint(1) NOT NULL DEFAULT '0',
  `spc_btn_id` varchar(20) DEFAULT NULL,
  `spc_txn_type` varchar(20) DEFAULT NULL,
  `spc_vat_amt` decimal(7,2) DEFAULT '0.00',
  `spc_payment_num` VARCHAR(255) DEFAULT NULL,
  `resource_id` int(11) NULL DEFAULT NULL,
  `processed` VARCHAR(5) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `trans_num` (`trans_num`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8";


 // Table structure for table `dap_users`
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `first_name` varchar(20) NOT NULL DEFAULT '',
  `last_name` varchar(20) DEFAULT NULL,
  `user_name` varchar(50) DEFAULT NULL,
  `email` varchar(60) NOT NULL DEFAULT '',
  `password` varchar(300) NOT NULL DEFAULT '',
  `salt` VARCHAR(255) DEFAULT NULL,
  `address1` varchar(100) DEFAULT NULL,
  `address2` varchar(40) DEFAULT NULL,
  `city` varchar(20) DEFAULT NULL,
  `state` varchar(20) DEFAULT NULL,
  `zip` varchar(10) DEFAULT NULL,
  `country` varchar(30) DEFAULT NULL,
  `shipping_address` varchar(100) DEFAULT NULL,
  `shipping_city` varchar(30) DEFAULT NULL,
  `shipping_state` varchar(30) DEFAULT NULL,
  `shipping_zip` varchar(10) DEFAULT NULL,
  `shipping_country` varchar(50) DEFAULT NULL,
  `phone` varchar(20) DEFAULT NULL,
  `fax` varchar(20) DEFAULT NULL,
  `company` varchar(40) DEFAULT NULL,
  `title` varchar(20) DEFAULT NULL,
  `is_affiliate` char(1) NOT NULL DEFAULT 'Y',
  `last_login_date` TIMESTAMP NULL,
  `activation_key` varchar(20) DEFAULT '0',
  `status` char(1) NOT NULL DEFAULT 'U',
  `login_count` int(11) NOT NULL DEFAULT '0',
  `ipaddress` varchar(100) DEFAULT '0.0.0.0',
  `account_type` char(1) NOT NULL DEFAULT 'U',
  `signup_date` TIMESTAMP NULL DEFAULT CURRENT_TIMESTAMP,
  `paypal_email` varchar(60) DEFAULT NULL,
  `last_update_date` TIMESTAMP NULL,
  `aff_nick` varchar(10) DEFAULT NULL,
  `opted_out` char(1) NOT NULL DEFAULT 'N',
  `self_service_status` char(1) NOT NULL DEFAULT 'I' COMMENT 'A/I (Active, Inactive)',
  `credits_available` int(11) NOT NULL DEFAULT '0',
  `exclude_iplogging` char(1) NOT NULL DEFAULT 'N',
  `reset_password_key` varchar(255) DEFAULT NULL,
  `gdpr_consent` VARCHAR(255) DEFAULT NULL,
  `gdpr_compliance_date` DATETIME NULL,
  `custom_role_id` int(11) NULL,
  `subaccount_type` VARCHAR(50) DEFAULT NULL,
  `parent_id` INT(11) DEFAULT NULL,	
  `user_image` TEXT DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `email` (`email`),
  UNIQUE KEY `user_name` (`user_name`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8" ;


// Table structure for table `dap_users_products_jn`
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_users_products_jn` (
  `user_id` int(11) NOT NULL DEFAULT '0',
  `product_id` int(11) NOT NULL DEFAULT '0',
  `access_start_date` date NULL,
  `access_end_date` date NULL,
  `transaction_id` int(11) DEFAULT '0' COMMENT '-1: direct sign up for free resources // -2: admin sign up for free resources // -3: admin paid sign up for all resources',
  `redeem_type` VARCHAR(255) DEFAULT NULL,
  `group_product_id` int(11) DEFAULT NULL,
  `coupon_id` int(11) DEFAULT NULL,
  `status` char(1) NOT NULL DEFAULT 'A',
  `ppp` char(1) NULL DEFAULT NULL,
  UNIQUE KEY `userproductkey` (`user_id`,`product_id`),
  KEY `user_id` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";


// Table structure for table `dap_users_resources_jn`
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_users_resources_jn` (
  `user_id` int(11) NOT NULL default '0',
  `resource_id` int(11) NOT NULL default '0',
  `click_count` int(3) NOT NULL default '0',
  UNIQUE KEY `user_resource` (`user_id`,`resource_id`),
  KEY `user_id` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ";


// Table structure for table `dap_users_logins`
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_users_logins` (
  `user_id` varchar(11) NOT NULL default '',
  `login_ip` varchar(100) NOT NULL default '',
  `time` timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY (`user_id`,`login_ip`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 ";

// Table structure for table `dap_users_credits`
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_users_credits` (
  `user_id` int(11) NOT NULL,
  `product_id` int(11) NOT NULL,
  `resource_id` int(11) NOT NULL,
  `transaction_id` int(11) NOT NULL DEFAULT '0',
  `credits_earned` int(11) NOT NULL DEFAULT '0',
  `credits_spent` int(11) NOT NULL DEFAULT '0',
  `datetime` TIMESTAMP NULL DEFAULT CURRENT_TIMESTAMP,
  `comments` varchar(50) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_users_custom` (
  `user_id` int(11) NOT NULL,
  `custom_id` int(11) NOT NULL,
  `custom_value` text,
  UNIQUE KEY `user_custom` (`user_id`,`custom_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_forum_priority` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `target_usergroupId` int(11) NOT NULL,
  `priority` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `uniqueindex` (`target_usergroupId`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_productforum` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `source_operation` varchar(50) NOT NULL,
  `source_product_id` int(11) NOT NULL,
  `target_operation` varchar(50) NOT NULL,
  `target_usergroup_id` int(11) NOT NULL,
  `Title` char(100) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `uniqueindex` (`source_operation`,`source_product_id`,`target_operation`,`Title`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_email_alias` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `email` varchar(50) CHARACTER SET utf8 NOT NULL,
  `source` varchar(20) CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `emailsource` (`email`,`source`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_cron` (
  `id` int(11) NOT NULL auto_increment,
  `description` text,
  `last_update_ts` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
    PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_data_mapping` (
  `id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `value` text NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_form_builder` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `form_name` varchar(200) NOT NULL DEFAULT '',
  `product_id` int(11) NOT NULL,
  `template_name` varchar(100) DEFAULT NULL,
  `template_data` longtext,
  `country` varchar(255) DEFAULT NULL,
  `state` varchar(255) DEFAULT NULL,
  `redirect_url` varchar(200) DEFAULT NULL,
  `autologin` char(1) NOT NULL DEFAULT 'Y',
  `captcha` varchar(10) NOT NULL DEFAULT 'N',
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `allow_file_upload` varchar(10) NULL DEFAULT NULL,
  `allowed_types_of_file` text NULL DEFAULT NULL,
  `max_file_upload_size` varchar(255)  NULL DEFAULT NULL,
  `max_number_of_files` varchar(255)  NULL DEFAULT NULL,
   PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_payment_plan` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `btn_id` varchar(30) NOT NULL,
  `user_id` int(11) DEFAULT NULL,
  `product_id` int(11) NOT NULL DEFAULT '0',
  `recurring_id` varchar(30) NOT NULL,
  `subscription_id` varchar(30) DEFAULT NULL,
  `txn_id` varchar(30) NOT NULL,
  `max_payments` int(11) NOT NULL,
  `actual_payments` int(11) NOT NULL,
  `status` varchar(20) NOT NULL,
  `date` TIMESTAMP NULL,
   PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_automation` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `created_date` DATETIME NULL DEFAULT NULL,
  `updated_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `type` varchar(255) NOT NULL,
  `product_id` int(11) DEFAULT NULL,
  `active` int(11) DEFAULT NULL,
   PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_automation_trigger` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `automation_id` int(11) NOT NULL,
  `trigger` varchar(255) NOT NULL,
   PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE  IF NOT EXISTS `dap_automation_trigger_action` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `trigger_id` int(11) NOT NULL,
  `destination` varchar(255) NOT NULL,
   PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_automation_trigger_action_data` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `automation_id` int(11) NOT NULL,
  `action_id` int(11) NOT NULL,
  `action_type` varchar(255) NOT NULL,
  `name` varchar(255) NOT NULL,
  `value` varchar(255) NOT NULL,
   PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_external_connections` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `connection_destination` varchar(255) NOT NULL,
  `connection_meta_key` varchar(255) NOT NULL,
  `connection_meta_value` varchar(300) NOT NULL,
   PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_product_role_mapping` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `product_id` int(11) NOT NULL,
  `role_id` int(11) NOT NULL,
  `number` int(11) NOT NULL,
  PRIMARY KEY (`id`)
)  ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_roles_master` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `description` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS  `dap_gdpr_settings` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
 `filter_gdpr_transactions` char(1)  NOT NULL DEFAULT 'N',
 `send_gdpr_tags` char(1) NOT NULL DEFAULT 'Y',
 `filter_existing_users` char(1) NOT NULL DEFAULT 'N',
 `user_country_for_gdpr` char(1) NOT NULL DEFAULT 'N',
 `send_admin_email` char(1) NOT NULL DEFAULT 'Y',
 PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_product_plan_mapping` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `product_id` int(11) NOT NULL,
  `stripe_plan` text  NOT NULL, 
  `stripe_mode` VARCHAR(10) NOT NULL,
  PRIMARY KEY (id)
  ) ENGINE=InnoDB DEFAULT CHARSET=utf8";
  
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_gdpr_countries` (
 `id` int(11) NOT NULL AUTO_INCREMENT,
 `country_name` varchar(100) NOT NULL,
 `country_code` varchar(10) NOT NULL,
 `status` int(11) NOT NULL DEFAULT '1',
 PRIMARY KEY (`id`)
  ) ENGINE=InnoDB DEFAULT CHARSET=utf8";  
  
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_spc_settings` (
 `id` int(11) NOT NULL AUTO_INCREMENT,
 `name` varchar(255)  NOT NULL,
 `value` varchar(255)  NOT NULL,
 `last_updated_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
 PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";  

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_capabilities` (
 `id` int(11) NOT NULL AUTO_INCREMENT,
 `name` varchar(50)  NOT NULL,
 `description` tinytext ,
 PRIMARY KEY (`id`),
 UNIQUE KEY `name` (`name`)
  ) ENGINE=InnoDB DEFAULT CHARSET=utf8";  
  
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_roles` (
 `id` int(11) NOT NULL AUTO_INCREMENT,
 `name` varchar(20)  NOT NULL,
 `description` tinytext ,
 PRIMARY KEY (`id`),
 UNIQUE KEY `name` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";  
          
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_roles_caps_jn` (
 `id` int(11) NOT NULL AUTO_INCREMENT,
 `roles_id` int(11) NOT NULL,
 `caps_id` int(11) NOT NULL,
 `allowed` char(1)  NOT NULL DEFAULT 'N',
 PRIMARY KEY (`id`)
)  ENGINE=InnoDB DEFAULT CHARSET=utf8";    
 
  
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_roles_product_access` (
 `id` int(11) NOT NULL AUTO_INCREMENT,
 `role_id` varchar(20)  NOT NULL,
 `products` varchar(255) NOT NULL,
 PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";  
 

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_email_reports` (
 `id` int(11) NOT NULL AUTO_INCREMENT,
 `tracking_id` varchar(255) DEFAULT NULL,
  `source` varchar(255) DEFAULT NULL,
  `subject` varchar(255) DEFAULT NULL,
 `event_type` varchar(255) NOT NULL,
 `total_emails` int(11) NOT NULL,
 `delivered` int(11) DEFAULT '0',
 `opens` int(11) DEFAULT '0',
 `clicks` int(11) DEFAULT '0',
 `bounced` int(11) DEFAULT '0',
 `unsubscribed` int(11) DEFAULT '0',
 `complained` int(11) DEFAULT '0',
 `last_updated` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
 PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8"; 
 
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_email_reports_clicks` (
 `id` int(11) NOT NULL AUTO_INCREMENT,
 `tracking_id` varchar(255)  NOT NULL,
 `email` varchar(255)  NOT NULL,
 `link` varchar(255) NOT NULL,
 `count` int(11) NOT NULL,
 `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
 PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_email_broadcasts` (
 `id` int(11) NOT NULL AUTO_INCREMENT,
 `broadcast_name` varchar(255)  DEFAULT NULL,
 `subject` varchar(255)  NOT NULL,
 `from_name` VARCHAR(100) NULL DEFAULT NULL,
 `from_email` VARCHAR(200) NULL DEFAULT NULL,
 `message` text  NOT NULL,
 `payload` text  NOT NULL,
 `payload1` text  NOT NULL,
 `email_group` int(11) NOT NULL,
 `tracking_id` varchar(255)  DEFAULT NULL,
 `last_updated` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
 `date_sent` timestamp NULL DEFAULT NULL,
 PRIMARY KEY (`id`)
)  ENGINE=InnoDB DEFAULT CHARSET=utf8";
 
$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_users_login_tracking` (
 `id` int(11) NOT NULL AUTO_INCREMENT,
`user_id` int(11) NOT NULL DEFAULT '0',
`login_ip` varchar(100) NOT NULL default '',
`country` varchar(50) NULL,
`action` varchar(10) NOT NULL default 'login',
`time` timestamp NOT NULL default CURRENT_TIMESTAMP,
PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE `dap_security_scan_settings` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `value` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE `dap_security_scan_report` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `filename` varchar(255) NOT NULL,
  `filepath` varchar(255) NOT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
   PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

//Game of Points -  Release

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_action_points` (
`id` int(11)  NOT NULL AUTO_INCREMENT,
`action` varchar(255) NOT NULL,
`type` varchar(255) DEFAULT NULL,
`value` longtext NOT NULL,
`credits` int(11) DEFAULT NULL,
`max_credits` int(11) DEFAULT NULL,
`duration` int(11) DEFAULT NULL,
`set_max_limit` VARCHAR(255) NULL DEFAULT NULL,
`courseid` VARCHAR(255) NULL DEFAULT NULL,
`moduleid` VARCHAR(255) NULL DEFAULT NULL,
`unitid` VARCHAR(255) NULL DEFAULT NULL,
`source` VARCHAR(50) NULL DEFAULT NULL,
`timer` INT(11) NULL DEFAULT '0',
`animation` VARCHAR(50) NULL DEFAULT NULL,
`animation_value` TEXT NULL DEFAULT NULL,
`message` TEXT NULL DEFAULT NULL,
`date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
 PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_user_credit_limit` (
`id` int(11)  NOT NULL AUTO_INCREMENT,
`user_id` int(11)  NOT NULL,
`action` varchar(255) NOT NULL,
`value` varchar(255)  NULL,
`credits_earned` int(11) DEFAULT NULL,
`total_credits` int(11) DEFAULT NULL,
`comments` longtext DEFAULT NULL,
`start_credits_date` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
`last_credits_date` timestamp NULL,
 PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_email_setting` (
`id` int(11) NOT NULL auto_increment,
`name` varchar(255) NOT NULL,
`email` varchar(255) NOT NULL, 
`date` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
 PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS  `dap_credit_history` (
 `id` int(11) NOT NULL auto_increment,
 `user_id` int(11) NOT NULL,
 `action` varchar(255) NOT NULL,
 `credits_earned` int(11) NOT NULL,
 `credits_spent` int(11) NOT NULL,
 `ip` varchar(255) NOT NULL,
 `country` varchar(255) NOT NULL,
 `page_id` int(11) NOT NULL,
 `product_id` int(11) NOT NULL,
 `value` varchar(255) NOT NULL,
 `course_id` INT(11) NULL,
 `course_data` VARCHAR(255) NULL,
 `comments` longtext  NOT NULL,
 `timestamp` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_credits_email_notification` (
 `id` int(11) NOT NULL auto_increment,
 `action` varchar(255) NOT NULL,
 `subject` text NOT NULL,
 `body` longtext NOT NULL,
 `date` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
 `status` int(11) NOT NULL,
 `admin_notification` INT(11) NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE `dap_users_badge` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` int(11) NOT NULL,
  `badge_id` int(11) NOT NULL,
  `date` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE `dap_leaderboad_disabled_users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
   PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_memberpages_values` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `action_id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `value` LONGTEXT NOT NULL,
   PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_memberpages` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `page_id` int(11) NOT NULL,
  `action` varchar(255) NOT NULL,
  `template` varchar(255) NOT NULL,
  `template_html` longtext NOT NULL,
  `styling_options` longtext NOT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `admin_email` VARCHAR(255) NULL,
   PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_memberpages_settings` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `action` varchar(255) NOT NULL,
  `name` varchar(255) NOT NULL,
  `value` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_gop_shortcode` (
 `id` int(11) NOT NULL AUTO_INCREMENT,
 `name` varchar(255) NOT NULL,
 `action` varchar(255) NOT NULL,
 `template` varchar(255) NOT NULL,
 `template_html` longtext DEFAULT NULL,
 `styling_options` longtext DEFAULT NULL,
 `date` timestamp NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_gop_shortcode_values` (
 `id` int(11) NOT NULL AUTO_INCREMENT,
 `action_id` int(11) NOT NULL,
 `name` varchar(255) NOT NULL,
 `value` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_course_module` (
`id` int(11) NOT NULL AUTO_INCREMENT,
`module_name` varchar(255) NOT NULL,
`module_desc` longtext NULL,
`course_id` int(11) NOT NULL,
`module_display_order` int(11) NULL,
`date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_user_course_progress` (
`id` int(11) NOT NULL AUTO_INCREMENT,
`user_id` int(11) NOT NULL,
`product_id` int(11) NOT NULL,
`module_id` int(11) NOT NULL,
`unit_id` int(11) NOT NULL,
`completed` varchar(255) NULL,
`initial_time_spent` INT(11) NULL,
`total_time_spent` INT(11) NULL,
`start_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
`date` timestamp NULL,
PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_products_tabs` (
`id` int(11) NOT NULL AUTO_INCREMENT, 
`product_id` int(11) NOT NULL,
`tab_list` text NULL,
`maintain` varchar(255) NULL,
`apply_tab_rule` CHAR(1) NULL,
`course_tab` CHAR(1) NULL,
`blogname` VARCHAR(30) NULL,
PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_onlinecourse` (
`id` int(11) NOT NULL AUTO_INCREMENT, 
`name` varchar(255) NULL,
`course_id` varchar(255) NULL,
`html` longtext NULL,
`customize_data` text NULL,
`reminder` CHAR(1) NULL,
`not_accessed_in_days` INT(11),
`reminder_body` TEXT NULL,
`reminder_subject` TEXT NULL,
`reminder_from` VARCHAR(255) NULL,
`reminder_name` VARCHAR(255) NULL,
`reminder_send_limit` INT(11) NULL,
`date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8"; 


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_failed_payment_settings` (
`id` int(11) NOT NULL AUTO_INCREMENT,
`payment_processor` varchar(50) NOT NULL,
`transaction_type` varchar(100) NOT NULL,
`subject` varchar(255) NOT NULL,
`body` mediumtext NOT NULL,
`send_email` varchar(10) DEFAULT 'no',
`send_admin_email` VARCHAR(5) DEFAULT 'N',
PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8"; 


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_users_products_failed_payments` (
`id` int(11) NOT NULL AUTO_INCREMENT,
`user_id` int(11) NOT NULL,
`product_id` int(11) NOT NULL,
`payment_processor` varchar(20) NOT NULL,
`transaction_type` varchar(100) NOT NULL,
`reason` varchar(255) NOT NULL,
`action` varchar(255) NOT NULL,
`transaction_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
`first_retry_date` TIMESTAMP NULL DEFAULT NULL,
`second_retry_date` TIMESTAMP NULL DEFAULT NULL,
`third_retry_date` TIMESTAMP NULL DEFAULT NULL,
`retries_status` VARCHAR(10) NOT NULL DEFAULT 'no',
PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8"; 

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_notifications_master` (
 `id` int(11) NOT NULL AUTO_INCREMENT, 
 `type` varchar(255) NOT NULL,
 `name` text NOT NULL,
 `value` longtext  NULL,
 `date` date NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8"; 

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_emailnotification` (
 `id` int(11) NOT NULL AUTO_INCREMENT, 
 `user_id` int(11) NOT NULL,
 `email_sent` varchar(255) NULL,
 `notification_type` varchar(255)  NULL,
 `date` date NOT NULL,
 `resent_date` date  NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE `dap_user_group_account` (
 `id` int(11) NOT NULL AUTO_INCREMENT,
 `userid` int(11) NOT NULL,
 `productid` int(11) NOT NULL,
 `seats` int(11) NOT NULL DEFAULT '0',
 `total_created` int(11) NOT NULL DEFAULT '0',
 `purchase_date` date NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";
  
$sql_ddl[] = "CREATE TABLE `dap_group_rules` (
 `id` int(11) NOT NULL AUTO_INCREMENT,
 `product_id` int(11) NOT NULL,
 `allowed_product_ids` varchar(255) DEFAULT NULL,
 `date` date NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_post_per_page_button_customizer` (
 `id` int(11) NOT NULL auto_increment,
 `button_type` varchar(50)  NOT NULL,
 `button_html` longtext  NOT NULL,
 `button_customizer` text  NOT NULL,
 `date` date NOT NULL,
  PRIMARY KEY  (`id`)
)ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_pay_per_post` (
 `id` int(11) NOT NULL auto_increment,
 `post_id` int(11) NOT NULL,
 `enable_pay_per_post` varchar(5)  NOT NULL,
 `post_image` varchar(255)  DEFAULT NULL,
 `show_teaser_content` varchar(5)  NOT NULL,
 `show_msg_above_btn` longtext ,
 `spc_checkout_id` int(11) NOT NULL,
 `not_logged_in` longtext ,
 `not_have_access` longtext ,
 `currency_symbol` varchar(255)  DEFAULT NULL,
 `currency_code` varchar(255)  DEFAULT NULL,
 `payment_mode` varchar(25)  DEFAULT NULL,
 `teaser_content` text  NOT NULL,
 `post_title` longtext  NOT NULL,
 `after_payment_action` varchar(20)  NOT NULL,
 `landing_url` varchar(255)  DEFAULT NULL,
 `post_url` varchar(255)  DEFAULT NULL,
 `product_id` int(11) DEFAULT NULL,
 `date` date NOT NULL,
 `button_layout_option` varchar(255) DEFAULT NULL,
 `content_description` TEXT DEFAULT NULL,
  PRIMARY KEY  (`id`)
)ENGINE=InnoDB DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_user_pay_per_post` (
 `id` int(11) NOT NULL auto_increment,
 `user_id` int(11) NOT NULL,
 `product_id` int(11) NOT NULL,
 `resource_id` int(11) NOT NULL,
 `access_start` date NOT NULL,
 `access_end` date NOT NULL,
 `purchase_status` varchar(50)  NOT NULL,
 `button_type` varchar(50)  NOT NULL,
 `post_url` varchar(255)  DEFAULT NULL,
  PRIMARY KEY  (`id`)
)ENGINE=InnoDB DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_pay_per_post_meta` (
 `id` int(11) NOT NULL auto_increment,
 `post_id` int(11) NOT NULL,
 `button_type` varchar(20)  NOT NULL,
 `price` varchar(20)  NOT NULL,
 `access_days` varchar(20)  NOT NULL,
 `btn_above_text` longtext  NOT NULL,
 `btn_text` text  NOT NULL,
 `shoppingcart` varchar(20)  NOT NULL,
 `buylink` varchar(255)  NOT NULL,
 `date` date NOT NULL,
  PRIMARY KEY  (`id`)
)ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE `dap_content_protection_rules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `blog_name` varchar(255) NOT NULL,
  `tag_id` int(11) NOT NULL,
  `product_id` varchar(255) NOT NULL,
   PRIMARY KEY (`id`)
)ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE `dap_setup_wizard` (
 `id` int(11) NOT NULL AUTO_INCREMENT,
  `product_id` int(11) NOT NULL,
  `tablist` TEXT NULL,
  `main_tablist` VARCHAR(50) NULL,
  `shopping_cart_platform` VARCHAR(50) NULL,
  `payment_gateway` VARCHAR(50) NULL,
  `wp_location` VARCHAR(50) NULL,
  `membership_pages` TEXT NULL,
  `date` date NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";
  
$sql_ddl[] = "CREATE TABLE `dap_course_lessons_meta` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `resource_id` int(11) NOT NULL,
  `image_url` text  NULL,
  `excerpt` longtext NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_tag_rules` (
`id` int(1) NOT NULL auto_increment,
`product_id` int(11) DEFAULT NULL,
`lesson_id` int(11) DEFAULT NULL,
`action` varchar(255)  DEFAULT NULL,
`add_tag_ids` varchar(255) DEFAULT NULL,
`remove_tag_ids` varchar(255) DEFAULT NULL,
`date` varchar(255)  NOT NULL,
PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_master_tags` (
 `id` int(11) NOT NULL auto_increment,
 `tag_name` varchar(255)  DEFAULT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_user_tag_action` (
`id` int(1) NOT NULL auto_increment,
`user_id` int(11) NOT NULL,
`automation_rule_id` int(11) NOT NULL,
`user_tag_id` int(11) NOT NULL,
`status` varchar(20) NOT NULL,
`date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_user_tags` (
`id` int(1) NOT NULL auto_increment,
`user_id` int(11) NOT NULL,
`tag_id` int(11) NOT NULL,
`type` varchar(255)  NOT NULL,
`product_id` int(11) NOT NULL,
`lesson_id` int(11) DEFAULT NULL,
`date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE `dap_buddyboss_mapping` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `product_id` varchar(255) DEFAULT NULL,
  `tag_id` varchar(255) DEFAULT NULL,
  `group_ids` varchar(255) DEFAULT NULL,
  `profiles` text DEFAULT NULL,
  `action` varchar(50)  DEFAULT NULL,
  `dest_action` varchar(50)  DEFAULT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
   PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";	

$sql_ddl[] = "CREATE TABLE `dap_users_files` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `filename` varchar(255)  NOT NULL,
  `url` text  NOT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";	

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_sqb_quiz_course_lessons` (
	`id` int(11) NOT NULL AUTO_INCREMENT,
	`quiz_id` int(11) NOT NULL,
	`course_id` int(11) NOT NULL,
	`lesson_ids` varchar(255) DEFAULT NULL,
	`blog_folder_name` varchar(255) DEFAULT NULL,
	`date` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
	PRIMARY KEY (`id`)	
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_certificate` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `status` varchar(255)  NOT NULL,
  `template_html` longtext  NOT NULL,
  `template_no` varchar(255)  NOT NULL,
  `customizer_values` text  NOT NULL,
  `name` varchar(255)  NOT NULL,
  `admin_name` varchar(255)  DEFAULT NULL,
  `logo_img` varchar(255)  DEFAULT NULL,
  `signature_img` varchar(255)  DEFAULT NULL,
  `type` CHAR(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_course_certificate` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `course_id` int(11) NOT NULL,
  `certificate_id` int(11) NOT NULL,
  `certificate_generation_criteria` varchar(255)  NOT NULL,
  `shortcode_type` varchar(255)  NOT NULL,
  `not_earned_certificate_option` varchar(255)  NOT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `status` varchar(255)  NOT NULL,
  `download_btn_html` longtext  NOT NULL,
  `download_customizer_values` varchar(255)  NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_user_certificate` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `course_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_download_all_certificates` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `status` varchar(255)  NOT NULL,
  `template_html` longtext  NOT NULL,
  `customizer_values` text  NOT NULL,
  `download_btn_text` varchar(255)  NOT NULL,
  `course_id` varchar(255)  NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_course_rules`(
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `course_id` int(11) DEFAULT 0,
  `module_id` int(11) DEFAULT 0,
  `resource_id` int(11) DEFAULT 0,
  `name` varchar(255)  NOT NULL,
  `value` text,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
   PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS  `dap_member_engagement_rules` (
   `id` int(11) NOT NULL auto_increment,
  `engagement_id` int(11) NOT NULL,  
  `display_option` varchar(255)  NOT NULL,
  `show_list` VARCHAR(255) NULL,
  `hide_list` varchar(255) NULL,
  `status` varchar(255)  NOT NULL,
  `show_slider` varchar(255)  DEFAULT NULL,
  `num_of_products` int(11) DEFAULT NULL,
  `template_num` varchar(255)  DEFAULT NULL,
  `total_num_of_products` int(11) DEFAULT NULL,
  `template_html` longtext ,
  `custom_values` longtext,
  `sorting_option` VARCHAR(255) DEFAULT NULL,
  `sorted_products_list` TEXT DEFAULT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
   PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_member_engagement` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255)  NOT NULL,
  `template` longtext  NOT NULL,
  `customized_values` text ,
  `template_num` varchar(255)  DEFAULT NULL,
  `type` varchar(255) DEFAULT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
   PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";


$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_referral_rules` (
  `id` int(11)  NOT NULL AUTO_INCREMENT,
  `product_id` int(11) NOT NULL,
  `total_referrals` int(11) NOT NULL,
  `billing_cycle` int(11) NOT NULL,
  `recurring` varchar(5) NOT NULL,
  `status` int(11) NOT NULL,
  `activate_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `date` date NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_affiliates_report` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `affiliate_id` int(11) NOT NULL,
  `userids` varchar(255) NOT NULL,
  `product_id` int(11) NOT NULL,
  `rules_total_cycle` int(11) NOT NULL,
  `rules_billing_cycle` int(11) NOT NULL,
  `extended_by_days` int(11) NOT NULL,
  `referral_bonus_date` date NOT NULL,
  `comments` text NOT NULL,  
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_course_prerequisite` (
`id` int(11) NOT NULL AUTO_INCREMENT,
`course_id` int(11) NOT NULL,
`prerequisite_ids` varchar(255) NOT NULL,
`page_url` text,
`error_msg` longtext,
`error_msg_text` longtext,
`date` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
`type` varchar(255) NOT NULL,
PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE `dap_content_protection_global_rules` (
  `id` int(11) NOT NULL auto_increment,
  `type` varchar(50) DEFAULT NULL,
  `has_access_to` varchar(255) DEFAULT NULL,
  `exception_ids` text DEFAULT NULL,
  `data` varchar(100) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `date` date NOT NULL,
  `status` char(1) DEFAULT NULL,
  `blog_folder_name` varchar(100) DEFAULT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_pay_using_credits` (
  `id` int(11) NOT NULL auto_increment,
  `page_id` int(11) NOT NULL,
  `product_id` int(11) NOT NULL,
  `status` char(1) NOT NULL,
  `button_html` text,
  `resource_id` int(11) NOT NULL,
  `redeem_after_redirect_url` varchar(255) DEFAULT NULL,
  `redeem_action_type` varchar(255) NOT NULL,
  `redeem_url` varchar(255) DEFAULT NULL,
  `image_src` varchar(255) DEFAULT NULL,
  `button_type` varchar(255) NOT NULL,
  `button_customizer_values` varchar(255) NOT NULL,
  `date` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS  `dap_pay_using_credits_details` (
  `id` int(11) NOT NULL auto_increment,
  `page_id` int(11) NOT NULL,
  `msg_above` text,
  `msg_below` text,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_course_lesson_template_details` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `product_id` int(11) NOT NULL,
  `module_id` int(11) DEFAULT '0',
  `resource_id` int(11) NOT NULL,
  `page_id` int(11) NOT NULL,
  `tab1` text,
  `tab2` text,
  `tab3` text,
  `tab4` text,
  `tab5` text,
  `customizer` text,
  `date` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
   PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_course_template_details` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `product_id` int(11) NOT NULL,
  `template_id` varchar(255) NOT NULL,
  `template_data` text NOT NULL,
  `customize_values` text NOT NULL,
  `date` timestamp  NULL DEFAULT CURRENT_TIMESTAMP,
  `status` char(1) DEFAULT NULL,
   PRIMARY KEY (`id`)
)ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_gop_badge` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `criteria` varchar(255) NOT NULL,
  `badge_image_url` text,
  `badge_html` text NOT NULL,
  `badge_customizer` text,
  `send_email_status` char(1) NOT NULL,
  `from_email` varchar(50) DEFAULT NULL,
  `from_name` varchar(50) DEFAULT NULL,
  `email_subject` varchar(255) NOT NULL,
  `email_body` varchar(255) NOT NULL,
  `display_message` text,
  `date` timestamp  NULL DEFAULT CURRENT_TIMESTAMP,
   PRIMARY KEY (`id`)
)ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS  `dap_gop_badge_steps` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `badge_id` int(11) NOT NULL,
  `action` varchar(255) NOT NULL,
  `value` varchar(255) DEFAULT NULL,
  `total_times` varchar(255) DEFAULT NULL,
  `limited_to` varchar(255) DEFAULT NULL,
  `limit_by` varchar(255) DEFAULT NULL,
  `status` char(1) DEFAULT NULL,
   PRIMARY KEY (`id`)
)ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_gop_user_badge_action_eligible` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `badge_id` int(11) NOT NULL,
  `action` varchar(255) NOT NULL,
  `value` varchar(11) DEFAULT NULL,
  `date_earned` timestamp  NULL DEFAULT CURRENT_TIMESTAMP,
   PRIMARY KEY (`id`)
)ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_course_modules_lessons_automations` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `course_id` int(11) NOT NULL,
  `module_id` int(11) DEFAULT NULL,
  `resource_id` int(11) NOT NULL,
  `send_email` char(1) DEFAULT 'N',
  `email_subject` text,
  `email_body` text,
  `display_message` char(1) DEFAULT 'N',
  `message_body` text,
  `points` char(1) DEFAULT 'N',
  `bonus` char(1) DEFAULT 'N',
  `bonus_value` varchar(255) DEFAULT NULL,
  `animation` char(1) DEFAULT 'N',
  `animation_html` text,
  PRIMARY KEY (`id`)
)ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE IF NOT EXISTS `dap_users_course_report` (
 `id` int(11)  NOT NULL AUTO_INCREMENT,
 `user_id` int(11) NOT NULL,
 `course_id` int(11) NOT NULL,
 `reminder_count` int(11) DEFAULT NULL,
 `reminder`  CHAR(1) NULL DEFAULT NULL,
 `dates` varchar(255) DEFAULT NULL,
  PRIMARY KEY  (`id`)
)ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE `dap_security_blocking_master` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `rule_name` varchar(255) DEFAULT NULL,
  `status` char(1) DEFAULT NULL,
  PRIMARY KEY  (`id`)
)ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE `dap_security_blocking_rule` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `rule_id` int(11) DEFAULT NULL,
  `value` varchar(255) DEFAULT NULL,
   PRIMARY KEY  (`id`)
)ENGINE=InnoDB DEFAULT CHARSET=utf8";

$sql_ddl[] = "CREATE TABLE `dap_security_reports` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `email` varchar(100) DEFAULT NULL,
  `domain` varchar(100) DEFAULT NULL,
  `IP` varchar(255) DEFAULT NULL,
  `country` varchar(150) DEFAULT NULL,
  `security_blocking_rule_id` int(11) DEFAULT NULL,
  `comments` varchar(255) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
   PRIMARY KEY  (`id`)
)ENGINE=InnoDB DEFAULT CHARSET=utf8";

?>