<?php
class DAP_MemberEngagement{
	
	var $id;
	var $name;
	var $template;	 
	var $customized_values;	 
	var $template_num;	 
	var $type;	 
	var $date;
	
	function getId() {
		return $this->id;
	}
	
	function setId($o) {
		$this->id = $o;
	}
	
	function getName() {
		return $this->name;
	}
	
	function setName($o) {
		$this->name = $o;
	}
	
	function getTemplate() {
		return $this->template;
	}
	
	function setTemplate($o) {
		$this->template = $o;
	}
	
	function getCustomizedValues() {
		return $this->customized_values;
	}
	
	function setCustomizedValues($o) {
		$this->customized_values = $o;
	}
	
	function getTemplateNum() {
		return $this->template_num;
	}
	
	function setTemplateNum($o) {
		$this->template_num = $o;
	}
	
	function getType() {
		return $this->type;
	}
	
	function setType($o) {
		$this->type = $o;
	}
		
	function getDate() {
		return $this->date;
	}
	
	function setDate($o) {
		$this->date = $o;
	}
 
	
	public function create() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			 
			$sql = "insert into  dap_member_engagement
						(name, template,  type, customized_values,template_num, date)
					values
						(:name, :template,  :type,:customized_values,:template_num , now())";			
						
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':name', $this->getName(), PDO::PARAM_STR);
 			$stmt->bindParam(':template', $this->getTemplate(), PDO::PARAM_STR);
 			//$stmt->bindParam(':template_type', $this->getTemplateType(), PDO::PARAM_STR);
 			$stmt->bindParam(':customized_values', $this->getCustomizedValues(), PDO::PARAM_STR);
 			$stmt->bindParam(':template_num', $this->getTemplateNum(), PDO::PARAM_STR);
 			$stmt->bindParam(':type', $this->getType(), PDO::PARAM_STR);
				 	
			

			$stmt->execute();
 
			return $dap_dbh->lastInsertId();
			$stmt = null;
			$dap_dbh = null;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}

	
	
	
	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();			
			
			$sql = "update  dap_member_engagement set
						
						name = :name,
						template = :template,						
						type = :type,						
						customized_values = :customized_values,						
						template_num = :template_num,						
						date  = now() 
					where
						id = :id";
		 

		 
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
 			$stmt->bindParam(':name', $this->getName(), PDO::PARAM_STR);
			$stmt->bindParam(':template', $this->getTemplate(), PDO::PARAM_STR);
			$stmt->bindParam(':customized_values', $this->getCustomizedValues(), PDO::PARAM_STR);
			$stmt->bindParam(':template_num', $this->getTemplateNum(), PDO::PARAM_STR);
			$stmt->bindParam(':type', $this->getType(), PDO::PARAM_STR);
			
			$stmt->execute();		
			
			$stmt = null;
			$dap_dbh = null;

			return;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	
	//Load  
	public static function load() {
		$LoadList = null; 
		$sql = "select * from  dap_member_engagement ";		 

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();

			while ($row = $stmt->fetch()) {
				$data = new DAP_MemberEngagement(); 

				$data->setId( $row["id"] );
				$data->setName( $row["name"] );
				$data->setTemplate( $row["template"] );
				$data->setCustomizedValues( $row["customized_values"] ); 
				$data->setTemplateNum( $row["template_num"] ); 
				$data->setType( $row["type"] ); 
				$data->setDate( $row["date"] ); 
				$LoadList[] = $data;
			}

			return $LoadList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
 
	
	 
	 
	//Load  
	public static function loadById($id = 0) {
		
		$sql = "select * from dap_member_engagement where id = ".$id;		 

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();

			while ($row = $stmt->fetch()) {
				$data = new DAP_MemberEngagement(); 

				$data->setId( $row["id"] );
				$data->setName( $row["name"] );
				$data->setTemplate( $row["template"] );
				$data->setCustomizedValues( $row["customized_values"] ); 
				$data->setTemplateNum( $row["template_num"] ); 
				$data->setType( $row["type"] ); 
				$data->setDate( $row["date"] ); 
				return   $data;
			}

			return null;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public static function deleteById($id = ''){

		$sql = "delete from `dap_member_engagement` where `id` =:id";
		
		try{		
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':id', $id, PDO::PARAM_STR);
			$stmt->execute();
			return true;
	    } catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
				
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
       	 
	}
	
	
}
