<?php 
class DAP_PayPerPostCustomizer {
	
   	var $id;
   	var $button_type;
   	var $button_html;
   	var $button_customizer;
   	var $date; 
	
	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
	
	function getButtonType() {
		return $this->button_type;
	}
	function setButtonType($o) {
		$this->button_type = $o;
	}
	
	function getButtonHtml() {
		return $this->button_html;
	}
	function setButtonHtml($o) {
		$this->button_html = $o;
	}
	
	function getButtonCustomizer() {
		return $this->button_customizer;
	}
	function setButtonCustomizer($o) {
		$this->button_customizer = $o;
	}	 
	
	function getDate() {
		return $this->date;
	}
	function setDate($o) {
		$this->date = $o;
	}
 	
	public function create() {
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			echo $sql = "insert into dap_post_per_page_button_customizer
						( button_type, button_html, button_customizer, date)
					values 
						(:button_type,  :button_html, :button_customizer, now())";

			$stmt = $dap_dbh->prepare($sql);	 
 
			$stmt->bindParam(':button_type', $this->getButtonType(), PDO::PARAM_STR);
			$stmt->bindParam(':button_html', $this->getButtonHtml(), PDO::PARAM_STR);
			$stmt->bindParam(':button_customizer', $this->getButtonCustomizer(), PDO::PARAM_STR);
			 
 			$stmt->execute();			 
			$last_insert_id = $dap_dbh->lastInsertId();
 
			$stmt = null;
			$dap_dbh = null;
			return $last_insert_id;
	
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
 
	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
	
			$sql = "update 
					dap_post_per_page_button_customizer
					set
						 button_type =:button_type, 
						 button_html =:button_html, 
						 button_customizer =:button_customizer, 
						 date=now() 
					where
						id =:id ";
				 
			$stmt = $dap_dbh->prepare($sql);	
			
			$stmt->bindParam(':button_type', $this->getButtonType(), PDO::PARAM_STR);
			$stmt->bindParam(':button_html', $this->getButtonHtml(), PDO::PARAM_STR);
			$stmt->bindParam(':button_customizer', $this->getButtonCustomizer(), PDO::PARAM_STR);			 
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			$stmt->execute();
		 
			$stmt = null;
			$dap_dbh = null;
			
			return;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
	
 
	public static function load() {
		$dataarr = array();
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_post_per_page_button_customizer ORDER BY date DESC
					";
			//logToFile($sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			 
			$stmt->execute();
	
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new DAP_PayPerPostCustomizer();
 
				$data->setId( stripslashes($row["id"]) );
				$data->setButtonType( stripslashes($row["button_type"]) );
				$data->setButtonHtml( stripslashes($row["button_html"]) );
				$data->setButtonCustomizer( stripslashes($row["button_customizer"]) );				 
				$data->setDate( stripslashes($row["date"]) ); 
				$dataarr[] = $data;
			}			
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	}
	
	public static function loadByType($button_type) {
		$data = false;
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_post_per_page_button_customizer
					WHERE
						button_type =:button_type 
						
					";
			// logToFile("sql=".$sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':button_type', $button_type, PDO::PARAM_STR);
			$stmt->execute();
	         
		//	while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
			if ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new DAP_PayPerPostCustomizer();
 
				$data->setId( stripslashes($row["id"]) );
				$data->setButtonType( stripslashes($row["button_type"]) );
				$data->setButtonHtml( stripslashes($row["button_html"]) );
				$data->setButtonCustomizer( stripslashes($row["button_customizer"]) );				 
				$data->setDate( stripslashes($row["date"]) ); 
				

			}			
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $data;
	} 
	
	  
 
}
 
