<?php

class Dap_PayPerPostMeta {
	
	var $id;
	var $post_id;
	var $button_type;
	var $price;
	var $access_days;
	var $btn_above_text;
	var $btn_text;
	var $shoppingcart;
	var $buylink;
	var $date;
	
	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}

	function getPostId() {
		return $this->post_id;
	}
	function setPostId($o) {
		$this->post_id = $o;
	}
	
	function getButtonType() {
		return $this->button_type;
	}
	function setButtonType($o) {
		$this->button_type = $o;
	}
	
	function getPrice() {
		return $this->price;
	}
	function setPrice($o) {
		$this->price = $o;
	}
	
	function getAccessDays() {
		return $this->access_days;
	}
	function setAccessDays($o) {
		$this->access_days = $o;
	}
	
	function getBtnAboveText() {
		return $this->btn_above_text;
	}
	function setBtnAboveText($o) {
		$this->btn_above_text = $o;
	}
	
	function getBtnText() {
		return $this->btn_text;
	}
	function setBtnText($o) {
		$this->btn_text = $o;
	}
	
	function getShoppingCart() {
		return $this->shoppingcart;
	}
	function setShoppingCart($o) {
		$this->shoppingcart = $o;
	}
	
	function getBuyLink() {
		return $this->buylink;
	}
	function setBuyLink($o) {
		$this->buylink = $o;
	}
	
	function getDate() {
		return $this->date;
	}
	function setDate($o) {
		$this->date = $o;
	}
	
	public function create() {
		
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$sql = "insert into dap_pay_per_post_meta 
						(post_id, button_type, price, access_days, btn_above_text, btn_text, shoppingcart, buylink, date)
					values 
						(:post_id, :button_type, :price, :access_days, :btn_above_text, :btn_text, :shoppingcart, :buylink, now())";

			$stmt = $dap_dbh->prepare($sql);				 
				  
			$stmt->bindParam(':post_id', $this->getPostId(), PDO::PARAM_STR);
			$stmt->bindParam(':button_type', $this->getButtonType(), PDO::PARAM_STR);
			$stmt->bindParam(':price', $this->getPrice(), PDO::PARAM_STR);
			$stmt->bindParam(':access_days', $this->getAccessDays(), PDO::PARAM_STR);
			$stmt->bindParam(':btn_above_text', $this->getBtnAboveText(), PDO::PARAM_STR);
			$stmt->bindParam(':btn_text', $this->getBtnText(), PDO::PARAM_STR);
			$stmt->bindParam(':shoppingcart', $this->getShoppingCart(), PDO::PARAM_STR);
			$stmt->bindParam(':buylink', $this->getBuyLink(), PDO::PARAM_STR);
	 
			$stmt->execute();
			 
			$last_insert_id = $dap_dbh->lastInsertId();
	 
			$stmt = null;
			$dap_dbh = null;
			return $last_insert_id;
	
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
	
	
	
	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
 
			$sql = "update 
					dap_pay_per_post_meta
					set
						 post_id =:post_id, 
						 button_type =:button_type, 
						 price=:price,
						 access_days=:access_days,
						 btn_above_text=:btn_above_text,
						 btn_text=:btn_text,
						 shoppingcart=:shoppingcart,
						 buylink=:buylink,	 
						 date=now() 
					where
						id =:id ";

			$stmt = $dap_dbh->prepare($sql);	
			
			$stmt->bindParam(':post_id', $this->getPostId(), PDO::PARAM_STR);
			$stmt->bindParam(':button_type', $this->getButtonType(), PDO::PARAM_STR);
			$stmt->bindParam(':price', $this->getPrice(), PDO::PARAM_STR);
			$stmt->bindParam(':access_days', $this->getAccessDays(), PDO::PARAM_STR);
			$stmt->bindParam(':btn_above_text', $this->getBtnAboveText(), PDO::PARAM_STR);
			$stmt->bindParam(':btn_text', $this->getBtnText(), PDO::PARAM_STR);
			$stmt->bindParam(':shoppingcart', $this->getShoppingCart(), PDO::PARAM_STR);
			$stmt->bindParam(':buylink', $this->getBuyLink(), PDO::PARAM_STR);
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			$stmt->execute();
			
			$stmt = null;
			$dap_dbh = null;
			
			return;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
	
	
	
	
	public static function loadPayPerPostMetaByPostId($post_id) {
		$dap_dbh = Dap_Connection::getConnection();
		

		//Load product details from database
		$sql = "select *
			from
				dap_pay_per_post_meta
			where
				post_id = :post_id ";

		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':post_id', $post_id, PDO::PARAM_INT);
		$stmt->execute();
		
		$payperpostarray = array();
		
		//echo "sql: $sql<br>"; exit;
		//$result = mysql_query($sql);
		//echo "rows returned: " . mysql_num_rows($result) . "<br>";

		while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {				 
			$payperpost = new Dap_PayPerPostMeta();
			$payperpost->setId( $row["id"] );
			$payperpost->setPostId( stripslashes($row["post_id"]) );
			$payperpost->setButtonType( stripslashes($row["button_type"]) );
			$payperpost->setPrice( stripslashes($row["price"]) );
			$payperpost->setAccessDays( stripslashes($row["access_days"]) );
			$payperpost->setBtnAboveText( $row["btn_above_text"] );
			$payperpost->setBtnText( $row["btn_text"] );
			$payperpost->setShoppingCart( $row["shoppingcart"] );
			$payperpost->setBuyLink( $row["buylink"] );
			$payperpost->setDate( $row["date"] );
			
			$payperpostarray[] =  $payperpost;
	
		}

		return $payperpostarray;
	}
	
	
	public static function loadPayPerPostMetaByPostIdAndButton($post_id, $button_type) {
		$dap_dbh = Dap_Connection::getConnection();
		$product = null;

		//Load product details from database
		$sql = "select *
			from
				dap_pay_per_post_meta
			where
				post_id = :post_id";

		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':post_id', $post_id, PDO::PARAM_STR);
		$stmt->execute();
		
		
		//echo "sql: $sql<br>"; exit;
		//$result = mysql_query($sql);
		//echo "rows returned: " . mysql_num_rows($result) . "<br>";

		if ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
			$payperpost = new Dap_PayPerPostMeta();
			$payperpost->setId( $row["id"] );
			$payperpost->setPostId( stripslashes($row["post_id"]) );
			$payperpost->setButtonType( stripslashes($row["button_type"]) );
			$payperpost->setPrice( stripslashes($row["price"]) );
			$payperpost->setAccessDays( stripslashes($row["access_days"]) );
			$payperpost->setBtnAboveText( $row["btn_above_text"] );
			$payperpost->setBtnText( $row["btn_text"] );
			$payperpost->setShoppingCart( $row["shoppingcart"] );
			$payperpost->setBuyLink( $row["buylink"] );
			$payperpost->setDate( $row["date"] );
			
			
	
		}

		return $payperpost;
	}
	
	
	public static function loadPayPerPostMetaByPostIdAndButtonType($post_id, $button_type) {
		$dap_dbh = Dap_Connection::getConnection();
		$payperpost = null;

		//Load details from database
		$sql = "select *
			from
				dap_pay_per_post_meta
			where
				post_id = :post_id and button_type= :button_type";

		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':post_id', $post_id, PDO::PARAM_INT);
		$stmt->bindParam(':button_type', $button_type, PDO::PARAM_STR);
		$stmt->execute();

		if ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
			$payperpost = new Dap_PayPerPostMeta();
			$payperpost->setId( $row["id"] );
			$payperpost->setPostId( stripslashes($row["post_id"]) );
			$payperpost->setButtonType( stripslashes($row["button_type"]) );
			$payperpost->setPrice( stripslashes($row["price"]) );
			$payperpost->setAccessDays( stripslashes($row["access_days"]) );
			$payperpost->setBtnAboveText( $row["btn_above_text"] );
			$payperpost->setBtnText( $row["btn_text"] );
			$payperpost->setShoppingCart( $row["shoppingcart"] );
			$payperpost->setBuyLink( $row["buylink"] );
			$payperpost->setDate( $row["date"] );
			
			
	     
		}
        $dap_dbh = null;
		return $payperpost;
	}
	
	
	public static function DeletePayPerPostMetaByPostIdAndButtonType($post_id, $button_type){
		$dap_dbh = Dap_Connection::getConnection();
		
		//Load details from database
		$sql = "delete
			from
				dap_pay_per_post_meta
			where
				post_id = :post_id and button_type= :button_type";

		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':post_id', $post_id, PDO::PARAM_INT);
		$stmt->bindParam(':button_type', $button_type, PDO::PARAM_STR);
		$stmt->execute();

        $dap_dbh = null;
		return true;
	}
	
}	
