<?php
class DAP_SecurityBlockingRule{
	
	var $id;
	var $rule_id;
	var $value;		
	
	
	
	function getId() {
		return $this->id;
	}
	
	function setId($o) {
		$this->id = $o;
	}
	
	function getRuleId() {
		return $this->rule_id;
	}
	
	function setRuleId($o) {
		$this->rule_id = $o;
	}
	
	function getValue() {
		return $this->value;
	}
	
	function setValue($o) {
		$this->value = $o;
	}
	
	
	
	public function create() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			 
			$sql = "insert into  dap_security_blocking_rule
						(rule_id, value)
					values
						(:rule_id, :value)";			
				
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':rule_id', $this->getRuleId(), PDO::PARAM_INT);
 			$stmt->bindParam(':value', $this->getValue(), PDO::PARAM_STR);	 	

			$stmt->execute();
 
			return $dap_dbh->lastInsertId();
			$stmt = null;
			$dap_dbh = null;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}

	
	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();			
			
			$sql = "update  dap_security_blocking_rule set
						
						rule_id = :rule_id,						
						value = :value					
						
					where
						id = :id ";	
		 
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':rule_id', $this->getRuleId(), PDO::PARAM_INT);
 			$stmt->bindParam(':value', $this->getValue(), PDO::PARAM_STR);
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);	
			$stmt->execute();		
			
			$stmt = null;
			$dap_dbh = null;

			return $this->getId();

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	

	public static function load() {
		$LoadList = null; 
		$sql = "select * from  dap_security_blocking_rule ";		 

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();

			while ($row = $stmt->fetch()) {
				$data = new DAP_SecurityBlockingRule(); 
				$data->setId( $row["id"] );
				$data->setRuleId($row["rule_id"]);
				$data->setValue($row["value"]);
				$LoadList[] = $data;
			}

			return $LoadList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public static function loadByRuleId($rule_id = 0) {
		$LoadList = null; 
		$sql = "select * from dap_security_blocking_rule where rule_id =:rule_id";

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':rule_id', $rule_id, PDO::PARAM_INT);
			$stmt->execute();

			while ($row = $stmt->fetch()) {
				$data = new DAP_SecurityBlockingRule(); 
				$data->setId( $row["id"] );
				$data->setRuleId($row["rule_id"]);
				$data->setValue($row["value"]);
				$LoadList[] = $data;
			}

			return $LoadList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	public static function loadAlldata() {
		$LoadList = array(); 
		$sql = "select dp.id, dp.rule_id, dp.value , ds.rule_name, ds.status from dap_security_blocking_rule dp ,  dap_security_blocking_master ds where dp.rule_id = ds.id AND ds.status ='Y'";

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$LoadList[] =   $row;				
			}
			 
			return $LoadList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public static function delete($id = ''){

		$sql = "delete from `dap_security_blocking_rule` where `id` =:id";
		
		try{		
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':id', $id, PDO::PARAM_INT);
			$stmt->execute();
			return true;
	    } catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
				
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
       	 
	}
}
