<?php
class Dap_ContentProtectionGlobalRules {
	
	var $id;
	var $type;
	var $exception_ids;	
	var $has_access_to;
	var $data;
	var $description;	
	var $date;	
	var $blog_folder_name;	
	var $status;	
	
	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
	
	function getType() {
		return $this->type;
	}
	function setType($o) {
		$this->type = $o;
	}
	
	function getHasAccessTo() {
		return $this->has_access_to;
	}
	function setHasAccessTo($o) {
		$this->has_access_to = $o;
	}
	
	function getExceptionIds() {
		return $this->exception_ids;
	}
	function setExceptionIds($o) {
		$this->exception_ids = $o;
	}
	
	function getData() {
		return $this->data;
	}
	function setData($o) {
		$this->data = $o;
	}
	
	function getDescription() {
		return $this->description;
	}
	function setDescription($o) {
		$this->description = $o;
	}
	
	function getDate() {
		return $this->date;
	}
	function setDate($o) {
		$this->date = $o;
	}
	
	function getBlogFolderName() {
		return $this->blog_folder_name;
	}
	
	function setBlogFolderName($o) {
		$this->blog_folder_name = $o;
	}
	
	function getStatus() {
		return $this->status;
	}
	
	function setStatus($o) {
		$this->status = $o;
	}
	
	
	
	public function create() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
		
			$sql = "insert into dap_content_protection_global_rules
						(type, has_access_to, exception_ids, data, description, date, blog_folder_name, status)
					values
						(:type, :has_access_to, :exception_ids, :data, :description, now(), :blog_folder_name, :status)";

			$stmt = $dap_dbh->prepare($sql);
			
			$stmt->bindParam(':type', $this->getType(), PDO::PARAM_STR);
			$stmt->bindParam(':has_access_to', $this->getHasAccessTo(), PDO::PARAM_STR);
			$stmt->bindParam(':exception_ids', $this->getExceptionIds(), PDO::PARAM_STR);
			$stmt->bindParam(':data', $this->getData(), PDO::PARAM_STR);
			$stmt->bindParam(':description', $this->getDescription(), PDO::PARAM_STR);
			$stmt->bindParam(':blog_folder_name', $this->getBlogFolderName(), PDO::PARAM_STR);
			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_STR);
			$stmt->execute();
              
            $last_id = $dap_dbh->lastInsertId();  
            $stmt = null;
			$dap_dbh = null;  
			return $last_id;
			
			

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}

	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			
				$sql = "update dap_content_protection_global_rules set
							type = :type,
							has_access_to = :has_access_to,
							exception_ids = :exception_ids,
							data = :data,
							description = :description,
							blog_folder_name = :blog_folder_name,
							status = :status 
						    where id = :id";
			 
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':type', $this->getType(), PDO::PARAM_STR);
			$stmt->bindParam(':has_access_to', $this->getHasAccessTo(), PDO::PARAM_STR);
			$stmt->bindParam(':exception_ids', $this->getExceptionIds(), PDO::PARAM_STR);
			$stmt->bindParam(':data', $this->getData(), PDO::PARAM_STR);
			$stmt->bindParam(':description', $this->getDescription(), PDO::PARAM_STR);
			$stmt->bindParam(':blog_folder_name', $this->getBlogFolderName(), PDO::PARAM_STR);
			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_STR);
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			
			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;
		
			return;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public function updateByType($type) {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			
				$sql = "update dap_content_protection_global_rules set
							id = :id,
							has_access_to = :has_access_to,
							exception_ids = :exception_ids,
							data = :data,
							description = :description,
							blog_folder_name = :blog_folder_name,
							status = :status 
						    where type = :type";
			
			logToFile("updateByProductID: sql=".$sql,LOG_DEBUG_DAP);	
			$stmt = $dap_dbh->prepare($sql);
			
			$stmt->bindParam(':type', $this->getType(), PDO::PARAM_STR);
			$stmt->bindParam(':has_access_to', $this->getHasAccessTo(), PDO::PARAM_STR);
			$stmt->bindParam(':exception_ids', $this->getExceptionIds(), PDO::PARAM_STR);
			$stmt->bindParam(':data', $this->getData(), PDO::PARAM_STR);
			$stmt->bindParam(':description', $this->getDescription(), PDO::PARAM_STR);
			$stmt->bindParam(':blog_folder_name', $this->getBlogFolderName(), PDO::PARAM_STR);
			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_STR);
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			
			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;
		
			return;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public static function loadByType($type) {
		 
		$sql = "select * from dap_content_protection_global_rules
					where
						type = :type";
		

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':type', $this->getType(), PDO::PARAM_STR);
			$stmt->execute();
			
			$contentRulesList = array();
			
			while ($row = $stmt->fetch()) {
				$contentRules = new Dap_ContentProtectionGlobalRules();

				$contentRules->setId( $row["id"] );
				$contentRules->setType($row["type"]);
				$contentRules->setExceptionIds($row["exception_ids"]);
				$contentRules->setData($row["data"]);
				$contentRules->setDescription($row["description"]);
				$contentRules->setDate($row["date"]);
				$contentRules->setBlogFolderName($row["blog_folder_name"]);
				$contentRules->setStatus($row["status"]);
				$contentRulesList[] = $contentRules;
			}

			return $contentRulesList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public static function loadActiveRules($blogFolderName) {
		
		logToFile("DAP_ContentProtectionGlobalRules.class.php: blogFolderName=".$blogFolderName,LOG_DEBUG_DAP);
		try {
		  if($blogFolderName!="") {
			$sql = "select * from dap_content_protection_global_rules where status='Y' and blog_folder_name=:blog_folder";
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':blog_folder', $blogFolderName, PDO::PARAM_STR);
		  }
		  else {
			$sql = "select * from dap_content_protection_global_rules where status='Y' and (blog_folder_name is NULL or blog_folder_name='ROOT')";
			logToFile("DAP_ContentProtectionGlobalRules.class.php: blog empty",LOG_DEBUG_DAP);			
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
		  }
		  
		  $stmt->execute();		  
		  $contentRulesList = array(); 
		  
		  while ($row = $stmt->fetch()) {
			  $contentRules = new Dap_ContentProtectionGlobalRules();
			  
			  $contentRules->setId( $row["id"] );
			  $contentRules->setType($row["type"]);
			  $contentRules->setExceptionIds($row["exception_ids"]);
			  $contentRules->setHasAccessTo($row["has_access_to"]);
			  $contentRules->setData($row["data"]);
			  $contentRules->setDescription($row["description"]);
			  $contentRules->setDate($row["date"]);
			  $contentRules->setBlogFolderName($row["blog_folder_name"]);
			  $contentRules->setStatus($row["status"]);
			 // logToFile("DAP_ContentProtectionGlobalRules.class.php: load(): type=".$row["type"],LOG_DEBUG_DAP);
			  
			  $contentRulesList[] = $contentRules;
		  }
		  return $contentRulesList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	
	public static function load() {
		
		//logToFile("DAP_ContentProtectionGlobalRules.class.php: load(): ENTER",LOG_DEBUG_DAP);
		  
		$sql = "select * from dap_content_protection_global_rules";
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();
			
			
			$contentRulesList = array();
			
			while ($row = $stmt->fetch()) {
				$contentRules = new Dap_ContentProtectionGlobalRules();
				
				$contentRules->setId( $row["id"] );
				$contentRules->setType($row["type"]);
				$contentRules->setExceptionIds($row["exception_ids"]);
				$contentRules->setHasAccessTo($row["has_access_to"]);
				$contentRules->setData($row["data"]);
				$contentRules->setDescription($row["description"]);
				$contentRules->setDate($row["date"]);
				$contentRules->setBlogFolderName($row["blog_folder_name"]);
				$contentRules->setStatus($row["status"]);
				
				$contentRulesList[] = $contentRules;
			}
			
			

			return $contentRulesList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public function delete($id) {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$dap_dbh->beginTransaction();
			
			//$id = $this->getId();
			//delete from usersproducts table
			  $sql = "delete from  
					dap_content_protection_global_rules
					where id =:id"; 
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':id', $id, PDO::PARAM_INT);
			$stmt->execute();
			
			$dap_dbh->commit(); 
			
			$stmt = null;
			$dap_dbh = null;		
			return;			
		} catch (PDOException $e) {
			$dap_dbh->rollback();
			$stmt = null;
			$dap_dbh = null;				
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			$dap_dbh->rollback();
			$stmt = null;
			$dap_dbh = null;			
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}		
	}
	
	
	
	public static function loadByTypeAndBlogFolderName($type = '', $blog_folder_name = '') {
		 
		$sql = "select * from dap_content_protection_global_rules
					where 
						`type` = :type and `blog_folder_name` = :blog_folder_name";
		
        
		try {
			
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':type', $type, PDO::PARAM_STR);
			$stmt->bindParam(':blog_folder_name', $blog_folder_name, PDO::PARAM_STR);
			$stmt->execute();
			
			$contentRulesList = null;
			
			while ($row = $stmt->fetch()) {
				$contentRules = new Dap_ContentProtectionGlobalRules();

				$contentRules->setId( $row["id"] );
				$contentRules->setType($row["type"]);
				$contentRules->setExceptionIds($row["exception_ids"]);
				$contentRules->setData($row["data"]);
				$contentRules->setDescription($row["description"]);
				$contentRules->setDate($row["date"]);
				$contentRules->setBlogFolderName($row["blog_folder_name"]);
				$contentRules->setStatus($row["status"]);
				$contentRules->setHasAccessTo($row["has_access_to"]);
				$contentRulesList = $contentRules;
			}

			return $contentRulesList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	
}
