<?php
class Dap_ContentProtectionRules {
	
	var $id;
	var $blog_name;
	var $tag_id;
	var $product_id;	
	
	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
	
	function getBlogName() {
		return $this->blog_name;
	}
	function setBlogName($o) {
		$this->blog_name = $o;
	}
	
	function getTagId() {
		return $this->tag_id;
	}
	function setTagId($o) {
		$this->tag_id = $o;
	}
	
	function getProductId() {
		return $this->product_id;
	}
	function setProductId($o) {
		$this->product_id = $o;
	}
	
	
	public function create() {
		try {
			
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "insert into dap_content_protection_rules
						(blog_name , tag_id, product_id)
					values
						(:blog_name , :tag_id, :product_id)";

			$stmt = $dap_dbh->prepare($sql);
			
			$stmt->bindParam(':blog_name', $this->getBlogName(), PDO::PARAM_STR);
			$stmt->bindParam(':tag_id', $this->getTagId(), PDO::PARAM_INT);
			$stmt->bindParam(':product_id', $this->getProductId(), PDO::PARAM_STR);
			$stmt->execute();

			return $dap_dbh->lastInsertId();
			$stmt = null;
			$dap_dbh = null;

		} catch (PDOException $e) {
			
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}

	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			
				$sql = "update dap_content_protection_rules set
							product_id = :product_id 
						    where blog_name = :blog_name and tag_id=:tag_id";
			 
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':blog_name', $this->getBlogName(), PDO::PARAM_STR);
			$stmt->bindParam(':tag_id', $this->getTagId(), PDO::PARAM_INT);
			$stmt->bindParam(':product_id', $this->getProductId(), PDO::PARAM_STR);
			
			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;
		
			return;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
		
	public static function load() {
		 
		$sql = "select * from dap_content_protection_rules ";
		

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();
			
			$tagRulesList = array();
			
			while ($row = $stmt->fetch()) {
				$tagRules = new Dap_ContentProtectionRules();

				$tagRules->setId( $row["id"] );
				$tagRules->setBlogName($row["blog_name"]);
				$tagRules->setTagId($row["tag_id"]);
				$tagRules->setProductId($row["product_id"]);
				$tagRulesList[] = $tagRules;
			}

			return $tagRulesList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	
	public static function loadByTagId($tagId) {
		 
		$sql = "select * from dap_content_protection_rules
					where
						tag_id = $tagId";
		

		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();
			
			$tagRulesList = array();
			
			while ($row = $stmt->fetch()) {
				$tagRules = new Dap_ContentProtectionRules();

				$tagRules->setId( $row["id"] );
				$tagRules->setBlogName($row["blog_name"]);
				$tagRules->setTagId($row["tag_id"]);
				$tagRules->setProductId($row["product_id"]);
				$tagRulesList[] = $tagRules;
			}

			return $tagRulesList;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
		
	public static function loadByTagIdAndBlog($tagId , $blog_name) {
		 
		$sql = "select * from dap_content_protection_rules
					where
						`tag_id` = ".$tagId." and `blog_name` = '".$blog_name."' ";
	
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();
			
			$tagRules = false;
			
			while ($row = $stmt->fetch()) {
				$tagRules = new Dap_ContentProtectionRules();

				$tagRules->setId( $row["id"] );
				$tagRules->setBlogName($row["blog_name"]);
				$tagRules->setTagId($row["tag_id"]);
				$tagRules->setProductId($row["product_id"]);
				
			}

			return $tagRules;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}	
	
	public static function delete($tag_id,$blog_name = '') {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$dap_dbh->beginTransaction();
			
		
			  $sql = "delete from  
					dap_content_protection_rules
					where tag_id =:tag_id and blog_name = :blog_name";
					
					
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':tag_id', $tag_id, PDO::PARAM_INT);
			$stmt->bindParam(':blog_name', $blog_name, PDO::PARAM_STR);
		
			$stmt->execute();
			
			$dap_dbh->commit(); 
			
			$stmt = null;
			$dap_dbh = null;		
			return;			
		} catch (PDOException $e) {
			$dap_dbh->rollback();
			$stmt = null;
			$dap_dbh = null;				
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			$dap_dbh->rollback();
			$stmt = null;
			$dap_dbh = null;			
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}		
	}
	
	public static function getProductsByBlogAndTag($select_tag , $subfolder_name){
		$sql = "select * from dap_content_protection_rules
					where
						`tag_id` = ".$select_tag." and `blog_name` = '".$subfolder_name."' ";
	
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$stmt = $dap_dbh->prepare($sql);
			$stmt->execute();
			
			$tagRules = false;
			
			while ($row = $stmt->fetch()) {
				$tagRules = $row["product_id"];
				
			}

			return $tagRules;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}

}
