<?php
	
class Dap_CourseLessonsMeta {
	
   	var $id;
   	var $resource_id;
   	var $image_url;
   	var $excerpt;
  
	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
	
	function getResourceId() {
		return $this->resource_id;
	}
	function setResourceId($o) {
		$this->resource_id = $o;
	}

	function getImageURL() {
		return $this->image_url;
	}
	function setImageURL($o) {
		$this->image_url = $o;
	}
		
	function getExcerpt() {
		return $this->excerpt;
	}
	function setExcerpt($o) {
		$this->excerpt = $o;
	}	
	
	 
 
	public function create() {
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$sql = "insert into dap_course_lessons_meta
						(resource_id, image_url, excerpt)
					values 
						(:resource_id, :image_url, :excerpt)";

			$stmt = $dap_dbh->prepare($sql);		
			 
			$stmt->bindParam(':resource_id', $this->getResourceId(), PDO::PARAM_STR);
			$stmt->bindParam(':image_url', $this->getImageURL(), PDO::PARAM_STR);
			$stmt->bindParam(':excerpt', $this->getExcerpt(), PDO::PARAM_STR);			
 
 			$stmt->execute();			 
			$last_insert_id = $dap_dbh->lastInsertId();

			$stmt = null;
			$dap_dbh = null;
			return $last_insert_id;
	
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
 
	public function update() {
		try {
			logToFile("(Dap_Credits.update()) getMaxLimit : ".$this->getMaxLimit());
			$dap_dbh = Dap_Connection::getConnection();
 
			$sql = "update 
					dap_course_lessons_meta
					set
						 resource_id =:resource_id, image_url=:image_url, excerpt =:excerpt 
					where
						action =:action ";
					
			$stmt = $dap_dbh->prepare($sql);	
			
			$stmt->bindParam(':resource_id', $this->getResourceId(), PDO::PARAM_STR);
			$stmt->bindParam(':image_url', $this->getImageURL(), PDO::PARAM_STR);
			$stmt->bindParam(':excerpt', $this->getExcerpt(), PDO::PARAM_STR);	
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_STR);
			$stmt->execute();	
			 
			
			$stmt = null;
			$dap_dbh = null;
			
			return;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
	
	
	public function updateByResourceId() {
		try {
			logToFile("(Dap_CourseLessonsMeta.updateByResourceId()) call");
			$dap_dbh = Dap_Connection::getConnection();
	
			$sql = "update 
					dap_course_lessons_meta
					set
						  id =:id, image_url=:image_url, excerpt =:excerpt 
					where
						resource_id =:resource_id";
					
			$stmt = $dap_dbh->prepare($sql);	
			 
			$stmt->bindParam(':resource_id', $this->getResourceId(), PDO::PARAM_INT);
			$stmt->bindParam(':image_url', $this->getImageURL(), PDO::PARAM_STR);
			$stmt->bindParam(':excerpt', $this->getExcerpt(), PDO::PARAM_STR);	
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			$stmt->execute();
			 
			$stmt = null;
			$dap_dbh = null;
			
			return;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
	
	public static function load() {
		$courseLessonsData = array();
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_course_lessons_meta ORDER BY date DESC
					";
			//logToFile($sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			 
			$stmt->execute();
	
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$courselessons = new Dap_CourseLessonsMeta(); 
				$courselessons->setId( stripslashes($row["id"]) );
				$courselessons->setResourceId( stripslashes($row["resource_id"]) );
				$courselessons->setImageURL( stripslashes($row["image_url"]) );
				$courselessons->setExcerpt( stripslashes($row["excerpt"]) );
				$courseLessonsData[] = $courselessons;

			}
			
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $courseLessonsData;
	}
	
 
	public static function loadByResourceId($resource_id = '') {
		$courseLessonsData = array();
	 
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			   $sql = "SELECT 
						*
					FROM
						dap_course_lessons_meta
					WHERE
						resource_id =:resource_id
						
					";
			// logToFile("sql=".$sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':resource_id', $resource_id, PDO::PARAM_INT);
			
			$stmt->execute();
	        logToFile("sql=".$sql,LOG_DEBUG_DAP);
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$courselessons = new Dap_CourseLessonsMeta();
				$courselessons->setId( stripslashes($row["id"]) );
				$courselessons->setResourceId( stripslashes($row["resource_id"]) );
				$courselessons->setImageURL( stripslashes($row["image_url"]) );
				$courselessons->setExcerpt( stripslashes($row["excerpt"]) ); 
				$courseLessonsData[] = $courselessons;
 
			}			
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		 
		return $courseLessonsData;
	}
	
	
 
	public function delete($id) {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$dap_dbh->beginTransaction();
			
			//$id = $this->getId();
			//delete from usersproducts table
			  $sql = "delete from  
					dap_course_lessons_meta
					where id =:id"; 
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':id', $id, PDO::PARAM_INT);
			$stmt->execute();
			
			$dap_dbh->commit(); 
			
			$stmt = null;
			$dap_dbh = null;		
			return;			
		} catch (PDOException $e) {
			$dap_dbh->rollback();
			$stmt = null;
			$dap_dbh = null;				
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			$dap_dbh->rollback();
			$stmt = null;
			$dap_dbh = null;			
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}		
	}
	
 
	
}
 
