<?php
	
class Dap_CourseModuleLesson {
	
   	var $id;
   	var $course_id;
   	var $module_id;
   	var $resource_id;
   	var $send_email;
   	var $email_subject;
   	var $email_body;
   	var $display_message; 
   	var $message_body; 
   	var $points; 
   
   	var $bonus; 
   	var $bonus_value; 
   	var $animation; 
   	var $animation_html; 
   	
   
	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
	function getCourseId() {
		return $this->course_id;
	}
	function setCourseId($o) {
		$this->course_id = $o;
	}
	function getModuleId() {
		return $this->module_id;
	}
	function setModuleId($o) {
		$this->module_id = $o;
	}
	 function getResourceId() {
		return $this->resource_id;
	}
	function setResourceId($o) {
		$this->resource_id = $o;
	}	 
	function getSendEmail() {
		return $this->send_email;
	}
	function setSendEmail($o) {
		$this->send_email = $o;
	}
	function getEmailSubject() {
		return $this->email_subject;
	}
	function setEmailSubject($o) {
		$this->email_subject = $o;
	}
	
	function getEmailBody() {
		return $this->email_body;
	}
	function setEmailBody($o) {
		$this->email_body = $o;
	}
	
	function getDisplayMessage() {
		return $this->display_message;
	}
	function setDisplayMessage($o) {
		$this->display_message = $o;
	}
	function getMessageBody() {
		return $this->message_body;
	}
	function setMessageBody($o) {
		$this->message_body = $o;
	}
	
	function getPoints() {
		return $this->points;
	}
	function setPoints($o) {
		$this->points = $o;
	}
	
	function getBonus() {
		return $this->bonus;
	}
	function setBonus($o) {
		$this->bonus = $o;
	}
	function getBonusValue() {
		return $this->bonus_value;
	}
	function setBonusValue($o) {
		$this->bonus_value = $o;
	}
	function getAnimation() {
		return $this->animation;
	}
	function setAnimation($o) {
		$this->animation = $o;
	}
	function getAnimationHTML() {
		return $this->animation_html;
	}
	function setAnimationHTML($o) {
		$this->animation_html = $o;
	}
 
	public function create() {
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$sql = "insert into dap_course_modules_lessons_automations
						(  course_id,  module_id, resource_id, send_email, email_subject, email_body, display_message, message_body, points,  bonus, bonus_value, animation, animation_html)
					values 
						( :course_id, :module_id, :resource_id, :send_email, :email_subject, :email_body, :display_message, :message_body, :points, :bonus, :bonus_value, :animation, :animation_html)";

			$stmt = $dap_dbh->prepare($sql);
				 
 
			$stmt->bindParam(':course_id', $this->getCourseId(), PDO::PARAM_INT);
			$stmt->bindParam(':module_id', $this->getModuleId(), PDO::PARAM_INT);
			$stmt->bindParam(':resource_id', $this->getResourceId(), PDO::PARAM_INT);
			$stmt->bindParam(':send_email', $this->getSendEmail(), PDO::PARAM_STR);
			$stmt->bindParam(':email_subject', $this->getEmailSubject(), PDO::PARAM_STR);
			$stmt->bindParam(':email_body', $this->getEmailBody(), PDO::PARAM_STR);
			$stmt->bindParam(':display_message', $this->getDisplayMessage(), PDO::PARAM_STR);
			$stmt->bindParam(':message_body', $this->getMessageBody(), PDO::PARAM_STR);
			$stmt->bindParam(':points', $this->getPoints(), PDO::PARAM_STR);
			
			$stmt->bindParam(':bonus', $this->getBonus(), PDO::PARAM_STR);
			$stmt->bindParam(':bonus_value', $this->getBonusValue(), PDO::PARAM_STR);
			$stmt->bindParam(':animation', $this->getAnimation(), PDO::PARAM_STR);
			$stmt->bindParam(':animation_html', $this->getAnimationHTML(), PDO::PARAM_STR);
			
 			$stmt->execute();
			 
			$last_insert_id = $dap_dbh->lastInsertId();
	 
			$stmt = null;
			$dap_dbh = null;
			return $last_insert_id;
	
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
 
	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
	
			$sql = "update 
					dap_course_modules_lessons_automations
					set
						 course_id =:course_id, 
						 module_id =:module_id, 
						 resource_id =:resource_id, 
						 send_email =:send_email, 
						 email_subject =:email_subject, 
						 email_body =:email_body, 
						 display_message =:display_message, 
						 message_body =:message_body, 
						 points =:points, 
						
						 bonus =:bonus, 
						 bonus_value =:bonus_value, 
						 animation =:animation, 
						 animation_html =:animation_html 
					where
						id =:id ";
					
			$stmt = $dap_dbh->prepare($sql);	
			
			$stmt->bindParam(':course_id', $this->getCourseId(), PDO::PARAM_INT);
			$stmt->bindParam(':module_id', $this->getModuleId(), PDO::PARAM_INT);
			$stmt->bindParam(':resource_id', $this->getResourceId(), PDO::PARAM_INT);
			$stmt->bindParam(':send_email', $this->getSendEmail(), PDO::PARAM_STR);
			$stmt->bindParam(':email_subject', $this->getEmailSubject(), PDO::PARAM_STR);
			$stmt->bindParam(':email_body', $this->getEmailBody(), PDO::PARAM_STR);
			$stmt->bindParam(':display_message', $this->getDisplayMessage(), PDO::PARAM_STR);
			$stmt->bindParam(':message_body', $this->getMessageBody(), PDO::PARAM_STR);
			$stmt->bindParam(':points', $this->getPoints(), PDO::PARAM_STR);
			
			$stmt->bindParam(':bonus', $this->getBonus(), PDO::PARAM_STR);
			$stmt->bindParam(':bonus_value', $this->getBonusValue(), PDO::PARAM_STR);
			$stmt->bindParam(':animation', $this->getAnimation(), PDO::PARAM_STR);
			$stmt->bindParam(':animation_html', $this->getAnimationHTML(), PDO::PARAM_STR);
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			$stmt->execute();
			
			$stmt = null;
			$dap_dbh = null;
			
			return;
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}	
	}
	
 
	public static function load() {
		$dataarr = null;
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_course_modules_lessons_automations ORDER BY date DESC
					";
			//logToFile($sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			 
			$stmt->execute();
	
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new Dap_CourseModuleLesson();
				$data->setId( stripslashes($row["id"]) );
				$data->setCourseId( stripslashes($row["course_id"]) );
				$data->setModuleId( stripslashes($row["module_id"]) );
				$data->setResourceId( stripslashes($row["resource_id"]) );
				$data->setSendEmail( stripslashes($row["send_email"]) );
				$data->setEmailSubject( stripslashes($row["email_subject"]) );
				$data->setEmailBody( stripslashes($row["email_body"]) );
				$data->setDisplayMessage( stripslashes($row["display_message"]) );
				$data->setMessageBody( stripslashes($row["message_body"]) );
				$data->setPoints( stripslashes($row["points"]) );
			
				$data->setBonus( stripslashes($row["bonus"]) );
				$data->setBonusValue( stripslashes($row["bonus_value"]) );
				$data->setAnimation( stripslashes($row["animation"]) );
				$data->setAnimationHTML( stripslashes($row["animation_html"]) );
				$dataarr[] = $data;

			}
			 
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	}
	
	 public static function loadById($id = 0) {
		$dataarr = null;
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_course_modules_lessons_automations
					WHERE
						id =:id 
						
					";
			// logToFile("sql=".$sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':id', $id, PDO::PARAM_INT);
			$stmt->execute();
	         
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new Dap_CourseModuleLesson();
				$data->setId( stripslashes($row["id"]) );
				$data->setCourseId( stripslashes($row["course_id"]) );
				$data->setModuleId( stripslashes($row["module_id"]) );
				$data->setResourceId( stripslashes($row["resource_id"]) );
				$data->setSendEmail( stripslashes($row["send_email"]) );
				$data->setEmailSubject( stripslashes($row["email_subject"]) );
				$data->setEmailBody( stripslashes($row["email_body"]) );
				$data->setDisplayMessage( stripslashes($row["display_message"]) );
				$data->setMessageBody( stripslashes($row["message_body"]) );
				$data->setPoints( stripslashes($row["points"]) );
				
				$data->setBonus( stripslashes($row["bonus"]) );
				$data->setBonusValue( stripslashes($row["bonus_value"]) );
				$data->setAnimation( stripslashes($row["animation"]) );
				$data->setAnimationHTML( stripslashes($row["animation_html"]) );
				$dataarr = $data;
			}	
			$stmt = null;
			$dap_dbh = null;		
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	} 
	
	 public static function loadByCourseId( $course_id=0) {
		$dataarr = null;
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_course_modules_lessons_automations
					WHERE
						course_id =:course_id ";
			// logToFile("sql=".$sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);			 
			$stmt->bindParam(':course_id', $course_id, PDO::PARAM_STR);
			$stmt->execute();
	         
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new Dap_CourseModuleLesson();
				$data->setId( stripslashes($row["id"]) );
				$data->setCourseId( stripslashes($row["course_id"]) );
				$data->setModuleId( stripslashes($row["module_id"]) );
				$data->setResourceId( stripslashes($row["resource_id"]) );
				$data->setSendEmail( stripslashes($row["send_email"]) );
				$data->setEmailSubject( stripslashes($row["email_subject"]) );
				$data->setEmailBody( stripslashes($row["email_body"]) );
				$data->setDisplayMessage( stripslashes($row["display_message"]) );
				$data->setMessageBody( stripslashes($row["message_body"]) );
				$data->setPoints( stripslashes($row["points"]) );
				
				$data->setBonus( stripslashes($row["bonus"]) );
				$data->setBonusValue( stripslashes($row["bonus_value"]) );
				$data->setAnimation( stripslashes($row["animation"]) );
				$data->setAnimationHTML( stripslashes($row["animation_html"]) );
				$dataarr = $data;
			}	
			$stmt = null;
			$dap_dbh = null;		
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	} 
	
	
	 public static function loadByCourseIdAndModuleIdAndResourceId( $course_id=0, $module_id=0, $resource_id=0) {
		$dataarr = null;
		
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "SELECT 
						*
					FROM
						dap_course_modules_lessons_automations
					WHERE
						course_id =:course_id  and 
						module_id =:module_id  and 
						resource_id =:resource_id ";
			// logToFile("sql=".$sql,LOG_DEBUG_DAP);
			$stmt = $dap_dbh->prepare($sql);			 
			$stmt->bindParam(':course_id', $course_id, PDO::PARAM_INT);
			$stmt->bindParam(':module_id', $module_id, PDO::PARAM_INT);
			$stmt->bindParam(':resource_id', $resource_id, PDO::PARAM_INT);
			$stmt->execute();
	         
			while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$data = new Dap_CourseModuleLesson();
				$data->setId( stripslashes($row["id"]) );
				$data->setCourseId( stripslashes($row["course_id"]) );
				$data->setModuleId( stripslashes($row["module_id"]) );
				$data->setResourceId( stripslashes($row["resource_id"]) );
				$data->setSendEmail( stripslashes($row["send_email"]) );
				$data->setEmailSubject( stripslashes($row["email_subject"]) );
				$data->setEmailBody( stripslashes($row["email_body"]) );
				$data->setDisplayMessage( stripslashes($row["display_message"]) );
				$data->setMessageBody( stripslashes($row["message_body"]) );
				$data->setPoints( stripslashes($row["points"]) );
				
				$data->setBonus( stripslashes($row["bonus"]) );
				$data->setBonusValue( stripslashes($row["bonus_value"]) );
				$data->setAnimation( stripslashes($row["animation"]) );
				$data->setAnimationHTML( stripslashes($row["animation_html"]) );
				$dataarr = $data;
			}	
			$stmt = null;
			$dap_dbh = null;		
			
		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
		
		return $dataarr;
	} 
	
	 
	
	public static function delete($id = 0) {
		$dap_dbh = Dap_Connection::getConnection(); 
		$sql = "delete from dap_course_modules_lessons_automations where id = :id";
		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':id', $id, PDO::PARAM_INT);
		$stmt->execute();

		return $id;
	}
 
}
