<?php

class Dap_DownloadAllCertificates {
	var $id;
	var $template;
	var $template_html;	 
	var $course_id;	 
	
	var $customizer_values;	 
	var $date;
	var $status;
	var $download_btn_text;

	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
	
	function getTemplateHtml() {
		return $this->template_html;
	}
	function setTemplateHtml($o) {
		$this->template_html = $o;
	}
	function getCustomizerValues() {
		return $this->customizer_values;
	}
	function setCustomizerValues($o) {
		$this->customizer_values = $o;
	}
	
	
	
	
	
	function getStatus() {
		return $this->status;
	}
	
	function setStatus($o) {
		$this->status = $o;
	}
		
	function getDate() {
		return $this->date;
	}
	
	function setDate($o) {
		$this->date = $o;
	}
	
	
	function getDownloadBtnText() {
		return $this->download_btn_text;
	}
	
	function setDownloadBtnText($o) {
		$this->download_btn_text = $o;
	}
	
	function getCourseId() {
		return $this->course_id;
	}
	
	function setCourseId($o) {
		$this->course_id = $o;
	}
	
	
	
	
	public function create() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$sql = "insert into dap_download_all_certificates
						( template_html, customizer_values, date , status, download_btn_text, course_id)
					values
						(:template_html, :customizer_values, :date, :status, :download_btn_text, :course_id)";
			$stmt = $dap_dbh->prepare($sql);			
			

			
			
			$stmt->bindParam(':template_html', $this->getTemplateHtml(), PDO::PARAM_STR);
			$stmt->bindParam(':customizer_values', $this->getCustomizerValues(), PDO::PARAM_STR);
			$stmt->bindParam(':date', $this->getDate(), PDO::PARAM_STR);
			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_STR);
			$stmt->bindParam(':download_btn_text', $this->getDownloadBtnText(), PDO::PARAM_STR);
			$stmt->bindParam(':course_id', $this->getCourseId(), PDO::PARAM_STR);
			$stmt->execute();			
			$last_id = $dap_dbh->lastInsertId();
			$stmt = null;
			$dap_dbh = null;
			return $last_id;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "update dap_download_all_certificates set
					template_html = :template_html,
					customizer_values = :customizer_values,
					date = :date,
					download_btn_text = :download_btn_text,
					course_id = :course_id,
					status = :status
					where
						id = :id
					";
					
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':template_html', $this->getTemplateHtml(), PDO::PARAM_STR);
			$stmt->bindParam(':customizer_values', $this->getCustomizerValues(), PDO::PARAM_STR);
			$stmt->bindParam(':date', $this->getDate(), PDO::PARAM_STR);
			$stmt->bindParam(':status', $this->getStatus(), PDO::PARAM_STR);
			$stmt->bindParam(':download_btn_text', $this->getDownloadBtnText(), PDO::PARAM_STR);
			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
			$stmt->bindParam(':course_id', $this->getCourseId(), PDO::PARAM_STR);
			$stmt->execute();			
			
			
			
			
			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;

			return $this->getId();

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public static function loadById($id) {
		$dap_dbh = Dap_Connection::getConnection();
		$sqbdataReturn = null;

		//Load product details from database
		$sql = "select *
			from
				dap_download_all_certificates
			where
				id = :id";

		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':id', $id, PDO::PARAM_INT);
		$stmt->execute();
			if ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$sqbdata = new Dap_DownloadAllCertificates();					
				$sqbdata->setId( $row["id"] );
							
				$sqbdata->setTemplateHtml( stripslashes($row["template_html"]) );
				$sqbdata->setCustomizerValues( stripslashes($row["customizer_values"]) );
				$sqbdata->setDate( stripslashes($row["date"]) );
				$sqbdata->setStatus( stripslashes($row["status"]) );
				$sqbdata->setDownloadBtnText( stripslashes($row["download_btn_text"]));
				$sqbdata->setCourseId($row["course_id"]);
				
				
				$sqbdataReturn = $sqbdata;
			}

		return $sqbdataReturn;
	}
	 
	
	public static function load() {
		$dap_dbh = Dap_Connection::getConnection(); 
		$sqbdataarray = null;

		//Load product details from database
		$sql = "select * from dap_download_all_certificates ";
		$stmt = $dap_dbh->prepare($sql);
		$stmt->execute();
		while ($row = $stmt->fetch()) {
				$sqbdata = new Dap_DownloadAllCertificates();					
				$sqbdata->setId( $row["id"] );

				
				
				$sqbdata->setTemplateHtml( stripslashes($row["template_html"]) );
				$sqbdata->setCustomizerValues( stripslashes($row["customizer_values"]) );
				$sqbdata->setDate( stripslashes($row["date"]) );
				$sqbdata->setStatus( stripslashes($row["status"]) );
				$sqbdata->setDownloadBtnText( stripslashes($row["download_btn_text"]) );
				
				$sqbdata->setCourseId($row["course_id"]);
				$sqbdataarray[] = $sqbdata;
		}

		return $sqbdataarray;
	}
	
	
	 
	public static function deleteById($id = 0) {
		$dap_dbh = Dap_Connection::getConnection(); 
		$sql = "delete from dap_download_all_certificates where id = :id";
		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':id', $id, PDO::PARAM_INT);
		$stmt->execute();

		return $id;
	}
	
	
}
