<?php

class Dap_SQBQuizCourseLessons {
	var $id;
	var $quiz_id;
	var $course_id;
	var $lesson_ids;
	var $blog_folder_name;
	var $date;
	var $course_ids;
	var $lesson_id;

	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
	
	function getQuizId() {
		return $this->quiz_id;
	}
	function setQuizId($o) {
		$this->quiz_id = $o;
	}
	
	function getCourseId() {
		return $this->course_id;
	}
	function setCourseId($o) {
		$this->course_id = $o;
	}
	
	function getLessonIds() {
		return $this->lesson_ids;
	}
	function setLessonIds($o) {
		$this->lesson_ids = $o;
	}
		
	function getDate() {
		return $this->date;
	}
	function setDate($o) {
		$this->date = $o;
	}
	
	
	
	function getBlogFolderName() {
		return $this->blog_folder_name;
	}
	function setBlogFolderName($o) {
		$this->blog_folder_name = $o;
	}
	
	function getLessonId() {
		return $this->lesson_id;
	}
	function setLessonId($o) {
		$this->lesson_id = $o;
	}
	
	function getCourseIds() {
		return $this->course_ids;
	}
	function setCourseIds($o) {
		$this->course_ids = $o;
	}
	
	public function create() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$sql = "insert into dap_sqb_quiz_course_lessons
						(quiz_id, course_id, lesson_ids, blog_folder_name, date, course_ids, lesson_id)
					values
						(:quiz_id, :course_id, :lesson_ids, :blog_folder_name, :date,:course_ids, :lesson_id)";
			$stmt = $dap_dbh->prepare($sql);			
			
			$stmt->bindParam(':quiz_id', $this->getQuizId(), PDO::PARAM_INT);
			$stmt->bindParam(':course_id', $this->getCourseId(), PDO::PARAM_INT);
			$stmt->bindParam(':lesson_ids', $this->getLessonIds(), PDO::PARAM_STR);
			$stmt->bindParam(':blog_folder_name', $this->getBlogFolderName(), PDO::PARAM_STR);
			$stmt->bindParam(':date', $this->getDate(), PDO::PARAM_STR);
			$stmt->bindParam(':course_ids', $this->getCourseIds(), PDO::PARAM_STR);
			$stmt->bindParam(':lesson_id', $this->getLessonId(), PDO::PARAM_INT);
			$stmt->execute();			
			$last_id = $dap_dbh->lastInsertId();
			$stmt = null;
			$dap_dbh = null;
			return $last_id;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "update dap_sqb_quiz_course_lessons set
					quiz_id = :quiz_id,
					course_id = :course_id,
					lesson_ids = :lesson_ids,
					blog_folder_name = :blog_folder_name,
					date = :date,
					course_ids = :course_ids,
					lesson_id = :lesson_id
					
					where
						id = :id
					";
					
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':quiz_id', $this->getQuizId(), PDO::PARAM_INT);
			$stmt->bindParam(':course_id', $this->getCourseId(), PDO::PARAM_INT);
			$stmt->bindParam(':lesson_ids', $this->getLessonIds(), PDO::PARAM_STR);
			$stmt->bindParam(':blog_folder_name', $this->getBlogFolderName(), PDO::PARAM_STR);
 			$stmt->bindParam(':date', $this->getDate(), PDO::PARAM_STR);
 			$stmt->bindParam(':course_ids', $this->getCourseIds(), PDO::PARAM_STR);
			$stmt->bindParam(':lesson_id', $this->getLessonId(), PDO::PARAM_INT);
 			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
 			
			$stmt->execute();
			
			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;

			return;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public static function loadByCourseId($course_id) {
		$dap_dbh = Dap_Connection::getConnection();
		$sqbdataArray = array();

		//Load product details from database
		$sql = "select *
			from
				dap_sqb_quiz_course_lessons
			where
				course_id = :course_id";

		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':course_id', $course_id, PDO::PARAM_STR);
		$stmt->execute();
			while ($row = $stmt->fetch()) {
				$sqbdata = new Dap_SQBQuizCourseLessons();					
				$sqbdata->setId( $row["id"] );
				$sqbdata->setQuizId( stripslashes($row["quiz_id"]) );
				$sqbdata->setCourseId( stripslashes($row["course_id"]) );
				$sqbdata->setLessonIds( stripslashes($row["lesson_ids"]) );
				$sqbdata->setBlogFolderName( stripslashes($row["blog_folder_name"]) );
				$sqbdata->setDate( stripslashes($row["date"]) );
				$sqbdata->setCourseIds( stripslashes($row["course_ids"]) );
				$sqbdata->setLessonId( stripslashes($row["lesson_id"]) );
				
				
				$sqbdataArray[] = $sqbdata;
		}

		return $sqbdataArray;
	}
	
	public static function loadByQuizIdCourseId($quiz_id = 0,$course_id = 0) {
		$dap_dbh = Dap_Connection::getConnection();
		$sqbdataarray = array();

		//Load product details from database
		$sql = "select *
			from
				dap_sqb_quiz_course_lessons
			where
			    quiz_id = :quiz_id and  
				course_id = :course_id";

		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':course_id', $course_id, PDO::PARAM_INT);
		$stmt->bindParam(':quiz_id', $quiz_id, PDO::PARAM_INT);   
		$stmt->execute();
		while ($row = $stmt->fetch()) {
				$sqbdata = new Dap_SQBQuizCourseLessons();					
				$sqbdata->setId( $row["id"] );
				$sqbdata->setQuizId( stripslashes($row["quiz_id"]) );
				$sqbdata->setCourseId( stripslashes($row["course_id"]) );
				$sqbdata->setLessonIds( stripslashes($row["lesson_ids"]) );
				$sqbdata->setBlogFolderName( stripslashes($row["blog_folder_name"]) );
				$sqbdata->setDate( stripslashes($row["date"]) );
				$sqbdata->setCourseIds( stripslashes($row["course_ids"]) );
				$sqbdata->setLessonId( stripslashes($row["lesson_id"]) );
				$sqbdataarray[] = $sqbdata;
		}

		return $sqbdataarray;
	}
	
	
	public static function loadByQuizIdLessonId($quiz_id = 0,$lesson_id = 0) {
		$dap_dbh = Dap_Connection::getConnection();
		$sqbdataarray = null;

		//Load product details from database
		$sql = "select *
			from
				dap_sqb_quiz_course_lessons
			where
			    quiz_id = :quiz_id and  
				lesson_id = :lesson_id";

		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':lesson_id', $lesson_id, PDO::PARAM_INT);
		$stmt->bindParam(':quiz_id', $quiz_id, PDO::PARAM_INT);   
		$stmt->execute();
		while ($row = $stmt->fetch()) {
				$sqbdata = new Dap_SQBQuizCourseLessons();					
				$sqbdata->setId( $row["id"] );
				$sqbdata->setQuizId( stripslashes($row["quiz_id"]) );
				$sqbdata->setCourseId( stripslashes($row["course_id"]) );
				$sqbdata->setLessonIds( stripslashes($row["lesson_ids"]) );
				$sqbdata->setBlogFolderName( stripslashes($row["blog_folder_name"]) );
				$sqbdata->setDate( stripslashes($row["date"]) );
				$sqbdata->setCourseIds( stripslashes($row["course_ids"]) );
				$sqbdata->setLessonId( stripslashes($row["lesson_id"]) );
				$sqbdataarray = $sqbdata;
		}

		return $sqbdataarray;
	}
	
	public static function loadByLessonId($lesson_id = 0) {
		$dap_dbh = Dap_Connection::getConnection();
		$sqbdataarray = null;

		//Load product details from database
		$sql = "select *
			from
				dap_sqb_quiz_course_lessons
			where
			   
				lesson_id = :lesson_id";

		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':lesson_id', $lesson_id, PDO::PARAM_INT);
		
		$stmt->execute();
		while ($row = $stmt->fetch()) {
				$sqbdata = new Dap_SQBQuizCourseLessons();					
				$sqbdata->setId( $row["id"] );
				$sqbdata->setQuizId( stripslashes($row["quiz_id"]) );
				$sqbdata->setCourseId( stripslashes($row["course_id"]) );
				$sqbdata->setLessonIds( stripslashes($row["lesson_ids"]) );
				$sqbdata->setBlogFolderName( stripslashes($row["blog_folder_name"]) );
				$sqbdata->setDate( stripslashes($row["date"]) );
				$sqbdata->setCourseIds( stripslashes($row["course_ids"]) );
				$sqbdata->setLessonId( stripslashes($row["lesson_id"]) );
				$sqbdataarray = $sqbdata;
		}

		return $sqbdataarray;
	}
	
	
	
	public static function load() {
		$dap_dbh = Dap_Connection::getConnection(); 
		$sqbdataarray = array();

		//Load product details from database
		$sql = "select * from dap_sqb_quiz_course_lessons ";
		$stmt = $dap_dbh->prepare($sql);
		$stmt->execute();
		while ($row = $stmt->fetch()) {
				$sqbdata = new Dap_SQBQuizCourseLessons();					
				$sqbdata->setId( $row["id"] );
				$sqbdata->setQuizId( stripslashes($row["quiz_id"]) );
				$sqbdata->setCourseId( stripslashes($row["course_id"]) );
				$sqbdata->setLessonIds( stripslashes($row["lesson_ids"]) );
				$sqbdata->setBlogFolderName( stripslashes($row["blog_folder_name"]) );
				$sqbdata->setDate( stripslashes($row["date"]) );
				$sqbdata->setCourseIds( stripslashes($row["course_ids"]) );
				$sqbdata->setLessonId( stripslashes($row["lesson_id"]) );
				$sqbdataarray[] = $sqbdata;
		}

		return $sqbdataarray;
	}
	
	
	public static function loadByUniqueQuizId() { 
		$dap_dbh = Dap_Connection::getConnection(); 
		$sqbdataarray = array();

		//Load product details from database
		$sql = "select DISTINCT  * from dap_sqb_quiz_course_lessons  GROUP BY quiz_id";
		$stmt = $dap_dbh->prepare($sql);
		$stmt->execute();
		while ($row = $stmt->fetch()) {
				$sqbdata = new Dap_SQBQuizCourseLessons();					
				$sqbdata->setId( $row["id"] );
				$sqbdata->setQuizId( stripslashes($row["quiz_id"]) );
				$sqbdata->setCourseId( stripslashes($row["course_id"]) );
				$sqbdata->setLessonIds( stripslashes($row["lesson_ids"]) );
				$sqbdata->setBlogFolderName( stripslashes($row["blog_folder_name"]) );
				$sqbdata->setDate( stripslashes($row["date"]) );
				$sqbdata->setCourseIds( stripslashes($row["course_ids"]) );
				$sqbdata->setLessonId( stripslashes($row["lesson_id"]) );
				$sqbdataarray[] = $sqbdata;
		}

		return $sqbdataarray;
	}
	
	
	public static function loadByUniqueQuizIdByDistinctKey() { 
		$dap_dbh = Dap_Connection::getConnection(); 
		$sqbdataarray = array();

		//Load product details from database
		
		$sql = "select DISTINCT quiz_id, blog_folder_name  from dap_sqb_quiz_course_lessons"; 
		$stmt = $dap_dbh->prepare($sql);
		$stmt->execute();
		while ($row = $stmt->fetch()) {
				$sqbdata = new Dap_SQBQuizCourseLessons();					
				$sqbdata->setQuizId( stripslashes($row["quiz_id"]) );
				$sqbdata->setBlogFolderName( stripslashes($row["blog_folder_name"]) );
				$sqbdataarray[] = $sqbdata;
		}
 
		return $sqbdataarray;
	}
	
	
	public static function deleteById($id = 0) {
		$dap_dbh = Dap_Connection::getConnection(); 
		$sql = "delete from dap_sqb_quiz_course_lessons where id = :id";
		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':id', $id, PDO::PARAM_INT);
		$stmt->execute();

		return $id;
	}
	
	
}
