<?php

class Dap_UsersCourseReport {
	var $id;
	var $user_id;
	var $course_id;
	var $reminder_count;
	var $reminder;
	var $dates; 

	function getId() {
		return $this->id;
	}
	function setId($o) {
		$this->id = $o;
	}
	
	function getUserId() {
		return $this->user_id;
	}
	function setUserId($o) {
		$this->user_id = $o;
	}
	
	function getCourseId() {
		return $this->course_id;
	}
	function setCourseId($o) {
		$this->course_id = $o;
	}
	
	function getReminderCount() {
		return $this->reminder_count;
	}
	function setReminderCount($o) {
		$this->reminder_count = $o;
	}
	function getReminder() {
		return $this->reminder;
	}
	function setReminder($o) {
		$this->reminder = $o;
	}
		
	function getDates() {
		return $this->dates;
	}
	function setDates($o) {
		$this->dates = $o;
	}
	
	public function create() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			$sql = "insert into dap_users_course_report
						(user_id, course_id, reminder_count, reminder, dates)
					values
						(:user_id, :course_id, :reminder_count, :reminder, :dates)";
			$stmt = $dap_dbh->prepare($sql);			
			
			$stmt->bindParam(':user_id', $this->getUserId(), PDO::PARAM_INT);
			$stmt->bindParam(':course_id', $this->getCourseId(), PDO::PARAM_INT);
			$stmt->bindParam(':reminder_count', $this->getReminderCount(), PDO::PARAM_STR);
			$stmt->bindParam(':reminder', $this->getReminder(), PDO::PARAM_STR);
			$stmt->bindParam(':dates', $this->getdates(), PDO::PARAM_STR);
			 
			$stmt->execute();			
			$last_id = $dap_dbh->lastInsertId();
			$stmt = null;
			$dap_dbh = null;
			return $last_id;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	  
	public function update() {
		try {
			$dap_dbh = Dap_Connection::getConnection();
			
			$sql = "update dap_users_course_report set
					user_id = :user_id,
					course_id = :course_id,
					reminder_count = :reminder_count,
					reminder = :reminder,
					dates = :dates 
					where
						id = :id
					";
					
			$stmt = $dap_dbh->prepare($sql);
			$stmt->bindParam(':user_id', $this->getUserId(), PDO::PARAM_INT);
			$stmt->bindParam(':course_id', $this->getCourseId(), PDO::PARAM_INT);
			$stmt->bindParam(':reminder_count', $this->getReminderCount(), PDO::PARAM_STR);
			$stmt->bindParam(':reminder', $this->getReminder(), PDO::PARAM_STR);
			$stmt->bindParam(':dates', $this->getdates(), PDO::PARAM_STR);
 			$stmt->bindParam(':id', $this->getId(), PDO::PARAM_INT);
 			
			$stmt->execute();
			
			$stmt->execute();
			$stmt = null;
			$dap_dbh = null;

			return;

		} catch (PDOException $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		} catch (Exception $e) {
			logToFile($e->getMessage(),LOG_FATAL_DAP);
			throw $e;
		}
	}
	
	public static function loadById($id) {
		$dap_dbh = Dap_Connection::getConnection();
		$sqbdataArray = array();

		//Load product details from database
		$sql = "select *
			from
				dap_users_course_report
			where
				id = :id";

		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':id', $id, PDO::PARAM_INT);
		$stmt->execute();
			while ($row = $stmt->fetch()) {
				$sqbdata = new Dap_UsersCourseReport();					
				$sqbdata->setId( $row["id"] );
				$sqbdata->setUserId( stripslashes($row["user_id"]) );
				$sqbdata->setCourseId( stripslashes($row["course_id"]) );
				$sqbdata->setReminderCount( stripslashes($row["reminder_count"]) );
				$sqbdata->setReminder( stripslashes($row["reminder"]) );
				$sqbdata->setDates( stripslashes($row["dates"]) );
				 
				$sqbdataArray[] = $sqbdata;
		}

		return $sqbdataArray;
	}
	public static function loadByCourseId($course_id) {
		$dap_dbh = Dap_Connection::getConnection();
		$dataArray = array();

		//Load product details from database
		$sql = "select *
			from
				dap_users_course_report
			where
				course_id = :course_id";

		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':course_id', $course_id, PDO::PARAM_INT);
		$stmt->execute();
			while ($row = $stmt->fetch()) {
				$data = new Dap_UsersCourseReport();					
				$data->setId( $row["id"] );
				$data->setUserId( stripslashes($row["user_id"]) );
				$data->setCourseId( stripslashes($row["course_id"]) );
				$data->setReminderCount( stripslashes($row["reminder_count"]) );
				$data->setReminder( stripslashes($row["reminder"]) );
				$data->setDates( stripslashes($row["dates"]) );
				 
				$dataArray[] = $data;
		}

		return $dataArray;
	}
	public static function loadByUserIdAndCourseId($user_id, $course_id) {
		$dap_dbh = Dap_Connection::getConnection();
		$dataArray = array();

		//Load product details from database
		$sql = "select *
			from
				dap_users_course_report
			where
				user_id = :user_id AND 
				course_id = :course_id order by id desc";

		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
		$stmt->bindParam(':course_id', $course_id, PDO::PARAM_INT);
		$stmt->execute();
		while ($row = $stmt->fetch()) {
			$data = new Dap_UsersCourseReport();					
			$data->setId( $row["id"] );
			$data->setUserId( stripslashes($row["user_id"]) );
			$data->setCourseId( stripslashes($row["course_id"]) );
			$data->setReminderCount( stripslashes($row["reminder_count"]) );
			$data->setReminder( stripslashes($row["reminder"]) );
			$data->setDates( stripslashes($row["dates"]) );
			 
			$dataArray[] = $data;
		}

		return $dataArray;
	}
	 
	 
	
	public static function load() {
		$dap_dbh = Dap_Connection::getConnection(); 
		$dataArray = array();

		//Load product details from database
		$sql = "select * from dap_users_course_report ";
		$stmt = $dap_dbh->prepare($sql);
		$stmt->execute();
		while ($row = $stmt->fetch()) {
				$data = new Dap_UsersCourseReport();					
				$data->setId( $row["id"] );
				$data->setUserId( stripslashes($row["user_id"]) );
				$data->setCourseId( stripslashes($row["course_id"]) );
				$data->setReminderCount( stripslashes($row["reminder_count"]) );
				$data->setReminder( stripslashes($row["reminder"]) );
				$data->setDates( stripslashes($row["dates"]) );
				$dataArray[] = $data;
		}

		return $dataArray;
	}
	 
	
	public static function deleteById($id = 0) {
		$dap_dbh = Dap_Connection::getConnection(); 
		$sql = "delete from dap_users_course_report where id = :id";
		$stmt = $dap_dbh->prepare($sql);
		$stmt->bindParam(':id', $id, PDO::PARAM_INT);
		$stmt->execute();

		return $id;
	}
	
	
}
