<?php

class infusionsoft {

   function infusionsoft() // constructor
   {
   }

   //======== USER REGISTRATION / UPDATE / DELETE ========
	// Add if user not there,  else update 
	function register($userId, $productId, $params)
	{
		logToFile("infusionsoft.class.php: register(): calling storeAddress", LOG_INFO_DAP);
		
		$lldocroot = defined('SITEROOT') ? SITEROOT : $_SERVER['DOCUMENT_ROOT'];
		if(file_exists($lldocroot . "/dap/isdk.php")) include_once ($lldocroot . "/dap/isdk.php");
	
		$myApp = new iSDK;

		if ($myApp->cfgCon("demo")) {
			logToFile("dap-infusionsoft: Connected...", LOG_DEBUG_DAP);
		} else {
			logToFile("dap-infusionsoft: Failed to connect to Infusionsoft!");
			return;
		}

		$this->storeAddress($myApp, $userId, $productId, $params);
	}
		
	function storeAddress($myApp, $userId, $productId, $params){
		
		$dapuser = Dap_User::loadUserById($userId);
		$email = trim($dapuser->getEmail()); //required
		$username = trim($dapuser->getUser_name());
		$first_name = trim($dapuser->getFirst_name());  //optional but highly suggested
		$last_name = trim($dapuser->getLast_name()); //optional but highly suggested
		$password = $dapuser->getPassword();
		$client_ip = getIpOfUser(); //required
		$city = $dapuser->getCity();
		$address = $dapuser->getAddress1();
		$state = $dapuser->getState();
		$zip = $dapuser->getZip();
		
		$data = explode(":",$params);
		logToFile("infusionsoft.class.php: storeAddress(): email =" . $email, LOG_INFO_DAP);
		
		if(isset($data) && isset($data[1])) {
			logToFile("infusionsoft.class.php: found data1", LOG_INFO_DAP);
			$compaignId = $data[1]; 
		}
		
		if(isset($data) && isset($data[2])) {
			$groupId = $data[2]; 
		}
	
		logToFile("infusionsoft.class.php: call addCon , compaign id=" . $compaignId, LOG_INFO_DAP);
		logToFile("infusionsoft.class.php: call addCon , group id=" . $groupId, LOG_INFO_DAP);

		$returnFields = array('Id', 'FirstName', 'LastName','Password');
		$contactdata = $myApp->findByEmail($email, $returnFields);

		if(count($contactdata) > 0)
		{
			//logToFile("infusionsoft.class.php: EXISTING CONTACT: findByEmail returned firstname = ". $contactdata[0]['FirstName'], LOG_INFO_DAP);
			$contactId=$contactdata[0]['Id'];
			logToFile("infusionsoft.class.php: EXISTING CONTACT: findByEmail returned = ". $contactId, LOG_INFO_DAP);
		}

		if($contactId == "") {
			$conDat = array('FirstName' => $first_name,
						'LastName' => $last_name,
						'Email' => $email,
						'Password' => $password,
						'StreetAddress1' => $address,
						'City' => $city,
						'State' => $state,
						'PostalCode' => $zip); 
		
			$contactId = $myApp->addCon($conDat);
			logToFile("infusionsoft.class.php: NEW CONTACT ... added contactId=" . $contactId, LOG_INFO_DAP);
		}
		else {
			logToFile("infusionsoft.class.php: contact=$contactId already exists", LOG_INFO_DAP);	
		}
		
		if(isset($contactId)) {
			
			logToFile("infusionsoft.class.php: before update ... contactId=" . $contactId, LOG_INFO_DAP);
			
			$conDat = array('Password' => $password);
			$contactId = $myApp->updateCon($contactId, $conDat);
			
			logToFile("infusionsoft.class.php: after update ... contactId=" . $contactId, LOG_INFO_DAP);
			
			if($compaignId != "") {
				logToFile("infusionsoft.class.php: assign to compaign =" . $compaignId, LOG_INFO_DAP);
				$result = $myApp->campAssign($contactId, $compaignId);
				if($result==true)
					logToFile("infusionsoft.class.php: assigned $email to compaign=$compaignId successfully", LOG_INFO_DAP);
				else 
					logToFile("infusionsoft.class.php: failed to assign $email to compaign=" . $compaignId, LOG_INFO_DAP);
				
				if($groupId != "")  {
					$result = $myApp->grpAssign($contactId, $groupId);
					if($result==true)
						logToFile("infusionsoft.class.php: assigned $email to groupId=$groupId successfully", LOG_INFO_DAP);
					else 
						logToFile("infusionsoft.class.php: failed to assign $email to groupId=" . $groupId, LOG_INFO_DAP);	
				}
			}
		}
		else {
		  logToFile("infusionsoft.class.php: createContact request, empty object returned", LOG_INFO_DAP);
		}
		
		return 0;
		
	}
	
	function unregister($userId, $productId, $params)
	{
		logToFile("infusionsoft.class.php: register(): calling storeAddress", LOG_INFO_DAP);
		
		$lldocroot = defined('SITEROOT') ? SITEROOT : $_SERVER['DOCUMENT_ROOT'];
		if(file_exists($lldocroot . "/dap/isdk.php")) include_once ($lldocroot . "/dap/isdk.php");
		
		$myApp = new iSDK;

		if ($myApp->cfgCon("demo")) {
			logToFile("dap-infusionsoft: Connected...", LOG_DEBUG_DAP);
		} else {
			logToFile("dap-infusionsoft: Failed to connect to Infusionsoft!");
			return;
		}
		
		$this->removeAddress($myApp, $userId, $productId, $params);
	}
	
	
	function removeAddress($myApp, $userId, $productId, $params){
		
		$dapuser = Dap_User::loadUserById($userId);
		$email = trim($dapuser->getEmail());
		
		logToFile("infusionsoft.class.php: removeAddress(): email =" . $email, LOG_INFO_DAP);
		
		$data = explode(":",$params);
		
		if(isset($data) && isset($data[1])) {
			logToFile("infusionsoft.class.php: removeAddress(): found data1", LOG_INFO_DAP);
			$compaignId = $data[1]; 
		}
		
		if(isset($data) && isset($data[2])) {
			$groupId = $data[2]; 
		}
				
		$returnFields = array('Id', 'FirstName', 'LastName');
		$contactdata = $myApp->findByEmail($email, $returnFields);
		
		if(count($contactdata) > 0)
		{
			$contactId=$contactdata[0]['Id'];
			logToFile("infusionsoft.class.php: EXISTING CONTACT: findByEmail returned = ". $contactId, LOG_INFO_DAP);
			
			if($compaignId != "") {
				logToFile("infusionsoft.class.php: remove $email from compaign =" . $compaignId, LOG_INFO_DAP);
				$result = $myApp->campRemove($contactId, $compaignId);
				if($result==true)
					logToFile("infusionsoft.class.php: removed $email from compaign=$compaignId successfully", LOG_INFO_DAP);
				else 
					logToFile("infusionsoft.class.php: failed to remove $email from compaign=" . $compaignId, LOG_INFO_DAP);
				
				if($groupId != "")  {
					$result = $myApp->grpRemove($contactId, $groupId);
					if($result==true)
						logToFile("infusionsoft.class.php: removed $email from groupId=$groupId successfully", LOG_INFO_DAP);
					else 
						logToFile("infusionsoft.class.php: failed to remove $email from groupId=" . $groupId, LOG_INFO_DAP);	
				}
			}
			
		}
		else {
			logToFile("infusionsoft.class.php: CONTACT ($email) NOT FOUND in Infusionsoft", LOG_INFO_DAP);
		}
		
		return 0;
	
	}
			
} 
?>