<?php

class mailerlite {

   function mailerlite() // constructor
   {
   }

   //======== USER REGISTRATION / UPDATE / DELETE ========
	// Add if user not there,  else update 
	function register($userId, $productId, $params)
	{
		logToFile("mailerlite.class.php: register(): calling storeAddress", LOG_INFO_DAP);
		
		$this->storeAddress($userId, $productId, $params);
	}
		
	function storeAddress($userId, $productId, $params){
		
		$dapuser = Dap_User::loadUserById($userId);
		$email = trim($dapuser->getEmail());
		$username = trim($dapuser->getUser_name());
		$firstname = trim($dapuser->getFirst_name());
		$lastname = trim($dapuser->getLast_name());
		$password = $dapuser->getPassword();
		
		// Added by Veena - Retrieve Custom Fields for the user - 11/19/11
		$customfieldlist = Dap_API::loadCustomFieldsForUser($dapuser);
		if(isset($customfieldlist) && ($customfieldlist != NULL) && ($customfieldlist != "")) {
		  foreach ($customfieldlist as $key=>$val) {
		   // $key is the name of the field and $val is the value of the custom field
			logToFile("mailerlite.class.php:key=value: " . $key . "=" . $val, LOG_INFO_DAP);
		  }
		}
		// End custom field retrieval
		
		$data = explode(":",$params);
		
		logToFile("mailerlite.class.php: storeAddress(): email =" . $email, LOG_INFO_DAP);
		
		if(!preg_match("/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*$/i", $email)) {
			logToFile("mailerlite.class.php: storeAddress(): invalid email", LOG_INFO_DAP);
			return "Email address is invalid"; 
		}
	
		//include_once('MCAPISPC.class.php');
		
		// grab an API Key from http://admin.mailchimp.com/account/api/
		$api_key = $data[1];
		//$api = new MCAPISPC($api_key);

		logToFile("mailerlite.class.php: storeAddress(): api_key =" . $api_key, LOG_INFO_DAP);
		
		$list_id = $data[2];
		logToFile("mailerlite.class.php: storeAddress(): list_id =" . $list_id, LOG_INFO_DAP);
		
		
		
		//$api = new MCAPI('4f34766900f66832570f205fb08f164a-us2');
		
		// grab your List's Unique Id by going to http://admin.mailchimp.com/lists/
		// Click the "settings" link for the list - the Unique Id is at the bottom of that page. 
		//$list_id = "df11c84ab4";
	
		// Merge variables are the names of all of the fields your mailing list accepts
		// Ex: first name is by default FNAME
		// You can define the names of each merge variable in Lists > click the desired list > list settings > Merge tags for personalization
		// Pass merge values to the API in an array as follows
		
		$tag = $data[3];
		
		
		$sendPassword = $data[4];
		logToFile("mailerlite.class.php: storeAddress(): sendPassword =" . $sendPassword, LOG_INFO_DAP);
		//~ $mergeVars = array('FNAME'=>$firstname,
							//~ 'LNAME'=>$lastname,
							//~ 'MEMBERPASS'=>$password);				
		//~ if($api->listSubscribe($list_id, $email, $mergeVars) === true) {
			//~ logToFile("mailerlite.class.php: listSubscribe(): success", LOG_INFO_DAP);
			//~ // It worked!	
			//~ return 0; 
		//~ }else{
			//~ // An error ocurred, return error message
			//~ logToFile("mailerlite.class.php: listSubscribe(): error: ".$api->errorMessage, LOG_INFO_DAP);			
			//~ return 'Error: ' . $api->errorMessage; 
		//~ }			
		
		$memberId = md5(strtolower($email));
		//$dataCenter = substr($api_key,strpos($api_key,'-')+1);
		$url = 'https://api.mailerlite.com/api/v2/groups/'.$list_id.'/subscribers';
		
		$json = json_encode([
			'email' => $email,
			'name' => $firstname. ''. $lastname, 
		]);
		
		if($sendPassword == 'yes'){
			$json = json_encode([
				'email' => $email,
				'name' => $firstname. ''. $lastname, 
				'fields' => ['password' => $password],
			]);
		}
		
		

		$curl = curl_init();

		curl_setopt_array($curl, array(
		  CURLOPT_URL => $url,
		  CURLOPT_RETURNTRANSFER => true,
		  CURLOPT_ENCODING => "",
		  CURLOPT_MAXREDIRS => 10,
		  CURLOPT_TIMEOUT => 30,
		  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
		  CURLOPT_CUSTOMREQUEST => "POST",
		  CURLOPT_POSTFIELDS => $json,
		  CURLOPT_HTTPHEADER => array(
			"content-type: application/json",
			"x-mailerlite-apikey: $api_key"
		  ),
		));

		$response = curl_exec($curl);
		$err = curl_error($curl);
		$httpCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
		curl_close($curl);
		if($httpCode == "200"){
			logToFile("mailerlite.class.php: register(): Subscribed to list successfully", LOG_DEBUG_DAP);
		}
		else{
			$result1 = json_decode($result);
			logToFile("mailerlite.class.php: register(): List subscribe failed because ".$result1->detail, LOG_DEBUG_DAP);
		}   
		
	}
	
	function unregister($userId, $productId, $params)
	{
		logToFile("mailerlite.class.php: register(): calling storeAddress", LOG_INFO_DAP);
		
		$this->removeAddress($userId, $productId, $params);
	}
	
	
	function removeAddress($userId, $productId, $params){
		
		$dapuser = Dap_User::loadUserById($userId);
		$email = trim($dapuser->getEmail());
	
		$data = explode(":",$params);
		
		logToFile("mailerlite.class.php: removeAddress(): email =" . $email, LOG_INFO_DAP);
		
		if(!preg_match("/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*$/i", $email)) {
			return "Email address is invalid"; 
		}
	
	//	require_once('MCAPISPC.class.php');
		
		// grab an API Key from http://admin.mailchimp.com/account/api/
		$api_key = $data[1];
	//	$api = new MCAPISPC($api_key);

		logToFile("mailerlite.class.php: removeAddress(): api_key =" . $api_key, LOG_INFO_DAP);
		
		$list_id = $data[2];
		logToFile("mailerlite.class.php: removeAddress(): list_id =" . $list_id, LOG_INFO_DAP);
		
		
		
		$memberId = md5(strtolower($email));
		$url = 'https://api.mailerlite.com/api/v2/groups/'.$list_id.'/subscribers/'.$email;
	
		$json = json_encode([
			'email' => $email,
		]);

		$curl = curl_init();

		curl_setopt_array($curl, array(
		  CURLOPT_URL => $url,
		  CURLOPT_RETURNTRANSFER => true,
		  CURLOPT_ENCODING => "",
		  CURLOPT_MAXREDIRS => 10,
		  CURLOPT_TIMEOUT => 30,
		  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
		  CURLOPT_CUSTOMREQUEST => "DELETE",
		  CURLOPT_POSTFIELDS => $json,
		  CURLOPT_HTTPHEADER => array(
			"content-type: application/json",
			"x-mailerlite-apikey: $api_key"
		  ),
		));
		
		$response = curl_exec($curl);
		
		$err = curl_error($curl);
		$httpCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
		curl_close($curl);
		
		if($httpCode == "200"){
			logToFile("mailerlite.class.php: unregister(): UnSubscribed from list successfully", LOG_DEBUG_DAP);
		}
		else{
			$result1 = json_decode($result);
			logToFile("mailerlite.class.php: unregister(): List Unsubscribe failed because ".$result1->detail, LOG_DEBUG_DAP);
		}
		
	
	
	}
			
} 
?>
